(psc-include
 '(
   "stair/tread.lsp"
   "stair/util.lsp"
   ))

  ;;; create hor. stair dim with XDATA from stair selection
(defun-q c:stair-dim-hor ( / ent-lst dln stair-dim-sub land-dim-sub)
  "Adds a run dimension to a stair block"
    (initget "Y N")
    (if (not (= "Y" (getkword "Include Landings? [Yes/No]: <No>")))
      (setq ent-lst (get-stairland 'stair T))
      (setq ent-lst (get-stairland 'both T))
    ) ;_ if
    (if ent-lst
      (progn
        (setvar 'clayer "DIM")
        (set-active-dimstyle "STANDARD")
        ;;; stair-dim
        (defun stair-dim-sub ( / npt ins pt1 pt2 bex tex txt)
          (setq
            npt (calc-nose-pts)
            ins (cdr (assoc 10 (entget ent)))
            pt1 (mapcar '+ ins (car npt))
            pt2 (mapcar '+ ins (last npt))
            dln (mid-2-pts pt1 pt2)
            bex (mapcar '+ pt1 (list (* (- dir) bot_ext) (- rise_hgt)))
            tex (mapcar '+ pt2 (list (* dir top_ext) 0))
            txt (strcat
                  "<>\\P"
                  (itoa tread_qty)
                  "T@"
                  (rtos tread_depth 5)
                  "\""
                ) ;_ strcat
          ) ;_ setq
          (foreach v
            (append
             '(pt1 pt2 dln)
              (if (> bot_ext 0) '(bex))
              (if (> top_ext 0) '(tex))
            ) ;_ append
            (set v (3dpt (eval v)))
          ) ;_ foreach
          (stair-dim-format 'h
            (vla-AddDimRotated modelSpace pt1 pt2 dln 0)
          ) ;_ stair-dim-format
          (if (= 'variant (type bex))
            ( (lambda (dimObj)
                (vla-put-textoverride dimobj
                  (cond
                    ( (<= bot_ext 11.0) "{\\W0.4;<>}")
                    ( (<= bot_ext 22.0) "{\\W0.7;<>}")
                    ( (= T) "")
                  ) ;_ cond
                ) ;_ vla-put-textoverride
              ) ;_ lambda
              (vla-AddDimRotated modelSpace pt1 bex dln 0)
            )
          ) ;_ if
          (if (= 'variant (type tex))
            ( (lambda (dimObj)
                (vla-put-textoverride dimobj
                  (cond
                    ( (<= top_ext 11.0) "{\\W0.4;<>}")
                    ( (<= top_ext 22.0) "{\\W0.7;<>}")
                    ( (= T) "")
                  ) ;_ cond
                ) ;_ vla-put-textoverride
              ) ;_ lambda
              (vla-AddDimRotated modelSpace pt2 tex dln 0)
            )
          ) ;_ if
        ) ;_ defun stair-dim-sub
        ;;; land-dim
        (defun land-dim-sub ( / ins pt1 pt2 gap)
          (setq
            ins (cdr (assoc 10 (entget ent)))
            dln (cond
                  ( (cadr ent-lst)
                    (with-data (read-xdata (cadr ent-lst) "")
                     '(
                        (if (= app_id "Stair")
                          ( (lambda (n)
                              (mapcar '+ ins
                                (mid-2-pts (car n) (last n))
                              ) ;_ mapcar
                            ) ;_ lambda
                            (calc-nose-pts)
                          )
                          (mapcar '+ ins '(0 30))
                        ) ;_ if
                      )
                    ) ;_ with-data
                  ) ;_ condif
                  ( dln (vlax-safearray->list (vlax-variant-value dln)))
                  ( (= T) (mapcar '+ ins '(0 30)))
                ) ;_ cond
            gap (list
                  (+ (car ins) (* dir (+ plt_dpt back_gap)))
                  (cadr dln)
                ) ;_ list
            pt1 (mapcar '+ ins (list (* (- dir) stair_ndist) 0))
            pt2 (mapcar '+ ins (list (* dir plt_dpt) 0))
          ) ;_ setq
          (foreach v '(pt1 pt2 gap dln) (set v (3dpt (eval v))))
          (vla-AddDimRotated modelSpace pt1 pt2 dln 0)
          (vla-AddDimRotated modelSpace pt2 gap dln 0)
          (setq dln nil)
        ) ;_ defun land-dim-sub
      ) ;_ progn
    ) ;_ if
    (foreach ent ent-lst
      (with-data (read-xdata ent "")
       '(
          (cond
            ((= app_id "Stair") (stair-dim-sub))
            ((= app_id "Land") (land-dim-sub))
            ((= T) (princ))
          ) ;_ cond
        )
      ) ;_ with-data
      (setq ent-lst (cdr ent-lst))
    ) ;_ foreach
  )
(defun-r 'c:stair-dim-hor)

  ;;; overwrite hor. stair dim with CALCULATIONS from dim. lng.
(defun-q c:stair-dim-hor-ovr ( / dimObj dimLng txt)
  "Overwrites a horizontal stair dimension with a run tag"
    (setq
      dimObj (ename>vlobj (car (entsel "Pick Stair Run Dimension: ")))
      dimLng (vla-get-measurement dimObj)
      txt (strcat "<>\\P" (itoa (fix (/ dimLng 11.0))) "T@11\"")
    ) ;_ setq
    (stair-dim-format 'h dimObj)
  )
(defun-r 'c:stair-dim-hor-ovr)

  ;;; create ver. stair dim with XDATA from stair selection
(defun-q c:stair-dim-ver ( / ent-lst xin pt0 pt1 pt2 dln txt lvl)
  "Adds a rise dimension to a stair block"
    (setq
      ent-lst (get-stairland 'stair T)
      xin (car (getpoint "\n x-ins: "))
    ) ;_ setq
    (if ent-lst
      (progn
        (setq
          pt0 (list xin (caddr (assoc 10 (entget (car ent-lst)))))
          lvl (with-data (read-xdata (car ent-lst) "") '(level))
        ) ;_ setq
        (setvar 'clayer "DIM")
        (set-active-dimstyle "STANDARD")
      ) ;_ progn
    ) ;_ if
    (foreach ent ent-lst
      (with-data (read-xdata ent "")
       '(
          (setq
            pt1 (list xin (caddr (assoc 10 (entget ent))))
            pt2 (mapcar '+ pt1 (list 0 (cadr (last (calc-nose-pts)))))
            dln (list (+ xin 60) (cadr pt1))
            txt (strcat
                  "<>\\P"
                  (itoa rise_qty)
                  "R@"
                  (rtos rise_hgt 2 2)
                  "\"\\P"
                  (rtos (rtd (atan (/ rise_hgt tread_depth))) 2 2)
                  "%%d"
                ) ;_ strcat
          ) ;_ setq
          (if (or (not (= level lvl)) (null (cdr ent-lst)))
            (progn
              (vla-AddDimRotated
                modelSpace
                (3dpt pt0)
                (3dpt (if (null (cdr ent-lst)) pt2 pt1))
                (3dpt (mapcar '+ dln '(60 0)))
                (dtr 90)
              ) ;_ vla-AddDimRotated
              (setq
                pt0 pt1
                lvl level
              ) ;_ setq
            ) ;_ progn
          ) ;_ if
        )
      ) ;_ with-data
      (foreach v '(pt1 pt2 dln) (set v (3dpt (eval v))))
      (stair-dim-format 'v
        (vla-AddDimRotated modelSpace pt1 pt2 dln (dtr 90))
      ) ;_ stair-dim-format
      (setq ent-lst (cdr ent-lst))
    ) ;_ foreach
  )
(defun-r 'c:stair-dim-ver)

  ;;; overwrite ver. stair dim with CALCULATIONS from dim. lng.
(defun-q c:stair-dim-ver-ovr ( / dimObj dimLng qty hgt)
  "Overwrites a vertical dimension with a rise tag"
    (setq
      dimObj (ename>vlobj (car (entsel "Pick Stair Rise Dimension: ")))
      dimLng (vla-get-measurement dimObj)
      qty (if (= 0 (rem dimLng 7.0))
            (fix (/ dimLng 7.0))
            (1+ (fix (/ dimLng 7.0)))
          ) ;_ if
      hgt (/ dimLng qty)
      txt (strcat
            "<>\\P"
            (itoa qty)
            "R@"
            (rtos hgt 2 2)
            "\"\\P"
            (rtos (rtd (atan (/ hgt 11.0))) 2 2)
            "%%d"
          ) ;_ strcat
    ) ;_ setq
    (stair-dim-format 'v dimObj)
  )
(defun-r 'c:stair-dim-ver-ovr)

(defun-q c:stair-add-det ( / ent-lst add-dtl add-ldr ins off)
  "Adds detail numbers to a stair block"
    (setq ent-lst (get-stairland 'stair T))
    (if ent-lst
      (progn
        (defun add-dtl (p d)
          (vla-addcircle modelspace (3dpt p) 12)
          (add-polyline modelspace p '((-12 0 0) (12 0 0)) nil)
          (mapcar
           '(lambda (p d)
              (vla-put-stylename
                (vla-put-layer-r
                  (add-text modelspace p d 5.5 1.0 'middle)
                  "TEXT"
                ) ;_ vlax-put-property-r
                "Calibri"
              ) ;_ vla-put-stylename
            ) ;_ lambda
            (mapcar '(lambda (o) (mapcar '+ p o)) '((0 5) (0 -5)))
            (list (strcat "S" d) "SD?")
          ) ;_ mapcar
        ) ;_ defun add-dtl
        (defun add-ldr (p d)
          (vla-addcircle modelspace (3dpt p) 12)
          ( (lambda (lst) (add-polyline modelspace p lst nil))
            (mapcar
             '(lambda (l) (polar '(0 0 0) (dtr (* d -45)) (* d l)))
             '(-12 -18)
            ) ;_ mapcar
          )
        ) ;_ defun add-ldr
      ) ;_ progn
    ) ;_ if
    (foreach ent ent-lst
      (with-data (read-xdata ent "")
       '(
          (setq ins (cdr (assoc 10 (entget ent))))
          (setq off
            (mapcar '+
              (polar ins (dtr (* dir -45)) (* dir -30))
              (list (if (= ent (car ent-lst)) 0 (* dir -24)) 0)
            ) ;_ mapcar
          ) ;_ setq
          (add-ldr ins dir)
          (add-dtl off (substr bot_conn_full 1 3))
          (setq off
            (mapcar '+
              (polar ins (dtr (* dir 45)) (* dir 30))
              (setq ins
                (list
                  (* dir (+ bot_cdist bot_ext run top_ext top_cdist))
                  flight_hgt
                ) ;_ list
              ) ;_ setq
            ) ;_ mapcar
          ) ;_ setq
          (add-dtl off (substr top_conn_full 1 3))
          (if (= ent (last ent-lst))
            (add-ldr (mapcar '+ ins (cdr (assoc 10 (entget ent)))) (- dir))
          ) ;_ if
        )
      ) ;_ with-data
    ) ;_ foreach
  )
(defun-r 'c:stair-add-det)
