  (psc-include (list "land/land_supp.lsp" "land/util.lsp"))

  (setq *draw-xbrace-plot* "N")

  (defun-q c:draw-xbrace ( / lay obj-lst def-lst dat-lst)
  "Draws cross brace frames in section or elevation

When drawing a frame on the main landing block, posts are added automatically. If plotting
is not selected, the posts come in on the NO PLOT layer along with the frame.

This command edits the underlying block definition, so if multiple block references point
to the same landing, they will all have the brace frames added."
    (setq lay (getdkword '(0 "Y N") '*draw-xbrace-plot* "Plot X-Brace?"))
    (setq lay (if (= "Y" lay) "OBJ" "NO PLOT"))
    (setq
      obj-lst '((or (appid "Land") (appid "EndView")))
      obj-lst (ss->lst (ssget (dxf-filter obj-lst)))
      obj-lst (mapcar 'ename>vlobj obj-lst)
      def-lst (mapcar 'face-defs obj-lst)
      dat-lst (mapcar '(lambda (obj) (read-xdata obj "")) obj-lst)
    ) ;_ setq
    (map-apply
     '(lambda (obj def dat)
        (with-data dat '((face-draw obj def)))
        (vla-update obj)
      ) ;_ lambda
      (mapcar 'list obj-lst def-lst dat-lst)
    ) ;_ map-apply
    (princ)
  ) ;_ defun-q c:draw-xbrace
  (defun-r 'c:draw-xbrace)
