(defun-q c:editblock ( / selection source)
  "Command to edit any special block with the appropriate dialog

This is designed to be set as the default double-click action, so blocks can be edited by
double-clicking."
  (if (setq selection (ssget "I"))
      (setq source (ssname selection 0))
    (setq source (car (entsel "\nSelect block: "))
          selection (ssadd)))
  (ssadd source selection)
  (sssetfirst nil selection)
  (cond ((or (read-xdata source "Stair") (read-xdata source "3D_Stair"))
         (psc-include '("commands/stair.lsp"))
         (c:stair))
        ((or (read-xdata source "Land") (read-xdata source "3D_Land"))
         (psc-include '("commands/land.lsp"))
         (c:landing))
        ((or (read-xdata source "Guard") (read-xdata source "3D_Guard"))
         (psc-include '("commands/dd-guard.lsp"))
         (c:dd-guard))
        ((or (read-xdata source "Embed") (read-xdata source "3D_Embed"))
         (psc-include '("commands/embed.lsp"))
         (c:embed))
        (T (command "bedit")))
  (princ))
(defun-r 'c:editblock)
