(psc-include '("dialog/dialog.lsp"
               "fab/util.lsp"))

(defun-q c:edittable (/ cell table title)
  "Edits the description of an item in a material or hardware table.

In a material table, this command also updates the item weight."
  (setq cell (get-table-cell))
  (if (not cell) (error "No table selected"))
  (setq table (pop! 'cell)
        title (table-get-title table)
        data (list
              (list "desc"
                    (cond ((ends-with title "Material") (get-material))
                          ((ends-with title "Hardware") (get-hardware))))))
  (table-set-row table (car cell) data)
  (table--decimal-format-cell table (car cell) (vl-position "weight" (table-get-column-names table))))
(defun-r 'c:edittable)
