(defun-q c:embed-totals (/)
  "Adds a summary table to embeds sheet"
  (setq ebd-table (parse-table (get-table-by-title "EMBEDS"))
        data (combine-like-data
              (mapcar '(lambda(x) (#! '(("detail" #(nth 1 x))
                                        ("qty" #(atoi (nth 4 x)))
                                        ("length" #(nth 3 x)))))
                      ebd-table)
              '("detail" "length")
              nil)
        qty-table (vla-AddTable modelSpace
                                (3dpt (getpoint "\nInsert: "))
                                (+ (length data) 2)
                                3
                                18.5
                                60)
        row 1)
  (vla-put-StyleName qty-table "Embeds")
  (vla-SetText qty-table 0 0 "TOTALS")
  (vla-SetText qty-table 1 0 "DETAIL")
  (vla-SetText qty-table 1 1 "QTY")
  (vla-SetText qty-table 1 2 "LENGTH")
  (vla-put-RegenerateTableSuppressed qty-table :vlax-true)
  (while data
    (setq line (car data)
          data (cdr data)
          row (1+ row))
    (foreach col (range 0 3 1)
             (vla-SetText qty-table row col (cadr (nth col line)))))
  (vla-put-RegenerateTableSuppressed qty-table :vlax-false))
(defun-r 'c:embed-totals)
  
