;; Command to generate end views of stairs and landings

(psc-include '(
               "stair/endview.lsp"
               "land/endview.lsp"
               ))

(defun-q c:endview ( / enames xins lr eins tmp data stairs lands db pdb)
  "Draws an end view of a stair or landing

When inserting the view, only the X coordinate is considered. The Y coordinate will match
that of the main section block. The X coordinate can be to either side of the main
section, and the perspective will be handled accordingly, allowing sections to be cut to
either side of the main view."
  (setup-env nil)
  
  (setq enames (get-stairland 'both T))
  (if enames (progn
    (setq xins (car (getpoint "\nX insert: "))
          pdb (cadr (assoc "dist_btwn" (if (setq tmp (read-xdata (car enames) "Stair"))
                                           tmp
                                         (read-xdata (car enames) "Land"))))
          lr (if (< xins (cadr (assoc 10 (entget (car enames))))) 'left 'right))
    ;; calc inserts and offsets, and pass to draw functions
    (foreach ename enames
       (setq data (if (setq tmp (read-xdata ename "Stair")) tmp (read-xdata ename "Land"))
             db (?n (xd-value "dist_btwn" data))
             zp (if (= (cadr (assoc "z_pos" data)) "Near") 'near 'far)
             eins (cons xins
                        (cddr (assoc 10 (entget ename)))))
       (if (assoc "l-string_mat" data)
           (with-data data '((stair-endview-draw eins lr (/ pdb 2.0))))
           (with-data data '((land-endview-draw eins lr))))
       (setq xins ((if (or (and (= lr 'left)
                                (= zp 'near))
                           (and (= lr 'right)
                                (= zp 'far)))
                       - +)
                   xins (/ (- db (?n pdb)) 2.0))
             pdb db))))
  (princ))
(defun-r 'c:endview)

