(psc-include '("fab/data-export.lsp"))

(defun-q c:fabdata ()
  "Opens fab drawings, extracts shipping data, and saves it to a file

This is the replacement for the legacy CF command, but it isn't able to process legacy
drawings itself. For any drawings that were not created with the new templates, this
command will crash.

Removing any of the tables present in a fab drawing will cause this command to crash."
  (if *dev-mode*
      (fabdata-process-dwgs (get-files-this-dir nil))
      ((lambda(result)
         (if (vl-catch-all-error-p result)
             (progn
               (alert (catch-all-error result))
               (princ "Data export aborted due to error"))
             (princ "Data export complete")))
       (vl-catch-all-apply 'fabdata-process-dwgs (list (get-files-this-dir nil)))))
  (princ))
(defun-r 'c:fabdata)
