(psc-include '("dialog/dialog.lsp"
               "fab/util.lsp"))

(defun-q c:fabtemplate ( / fabtemplate-dialog job-info response stair style doc)
  "Creates a new drawing in the current folder from a built-in template

Running this command will prompt you for the stair name, as there is no way for the system
to know it. It may also prompt for a drawing description for the title block, if one isn't
already built in to the template."
  (defun fabtemplate-dialog (/
                             templates
                             ;; variables defined here for dialog-init
                             defaults-file
                             popup-keys
                             dist-keys
                             int-keys
                             toggle-keys
                             plain-string-keys
                             default-actions
                             dialog-ties
                             sub-dialogs
                             ;; variables included here for scope,
                             ;; but not defined here directly
                             extra-keys
                             tile-actions
                             )
    (setq templates
          '(("Generic fab x12" "fab12" nil)
            ("Generic fab x18" "fab18" nil)
            ("Generic fab x21" "fab21" nil)
            ("Generic fab x24" "fab24" nil)
            ("Generic fab x36" "fab36" nil)
            ("Generic ship loose table" "generic-ship-loose" nil)
            ("Landing hanger table" "land-hanger" "SHIP LOOSE HANGERS")
            ("Landing ledger table" "land-ledger" "SHIP LOOSE LEDGERS")
            ("Landing post table" "land-post" "SHIP LOOSE POSTS")
            ("Handrail return table" "handrail-return" "HANDRAIL RETURNS")
            ("100 stair rail sheet" "stair-rail-100" "STAIR RAILS")
            ("100 stair rail sheet (top mount)" "stair-rail-100-top" "STAIR RAILS")
            ("200 stair rail sheet" "stair-rail-200" "STAIR RAILS")
            ("200 stair rail sheet (top mount)" "stair-rail-200-top" "STAIR RAILS")
            ("300 stair rail sheet" "stair-rail-300" "STAIR RAILS")
            ("300 stair rail sheet (top mount)" "stair-rail-300-top" "STAIR RAILS")
            ("400 stair rail sheet" "stair-rail-400" "STAIR RAILS")
            ("400 stair rail sheet (top mount)" "stair-rail-400-top" "STAIR RAILS")
            ("Wall rail sheet" "wall-rail-std" "WALL RAILS")
            ("Wall rail w/ level-off sheet" "wall-rail-lvl" "WALL RAILS")
            ("Wall rail top splicer sheet" "wall-rail-top" "WALL RAILS")
            ("Wall rail bottom splicer sheet" "wall-rail-bot-std" "WALL RAILS")
            ("Wall rail w/ level off bottom splicer sheet" "wall-rail-bot-lvl" "WALL RAILS"))
          popup-keys (list (cons "templates" (mapcar 'car templates)))
          response (cdr (assoc (xd-value "templates"
                                      (dialog-init "fab/fabtemplate.dcl" "fabtemplate" source))
                               templates)))
    (list (strcat "fab/" (car response) ".dwt") (cadr response)))
  
  (setq job-info (get-job-info)
        response (fabtemplate-dialog)
        stair (getstring "\nStair: ")
        style (if (cadr response)
                  (cadr response)
                  (uppercase (getstring T "\nDrawing description: ")))
        doc (vla-Add (vla-get-Documents acadObj) (car response)))
  ((lambda(/ acadDoc modelSpace)
     (setq acadDoc doc
           modelSpace (vla-get-ModelSpace acadDoc)
           dwgno "$DWGNO")
     (write-title-block job-info stair (vla-getvar 'loginname) style)))
  (vla-Regen doc acAllViewPorts)
  (vla-Activate doc))
(defun-r 'c:fabtemplate)
