(setq *insertrows-nrows* 1)

(defun-q c:insertrows (/ cell table)
  "Inserts rows in a fab drawing table

In a generic fab drawing, the tables below the one you choose will be shifted to
accommodate the new rows.

If inserting rows in the material list above an existing standard-prefix part (e.g. AA;
i.e. not pans, STN, QT, or NRT), the mark numbers for parts below will be increased by the
number of rows added. This carries to the callouts in the drawing as well.

If inserting rows in the assembly table, the quantities in the material table will be
updated."
  (setq cell (get-table-cell))
  (if (not cell)
      (error "No table cell selected"))
  (setq table (pop! 'cell))
  (table-insert-rows table (getdint '*insertrows-nrows* "Number of rows to add") (car cell))
  (princ))
(defun-r 'c:insertrows)
