(psc-include '("dialog/dialog.lsp"))

(defun-q c:jobinfo ( /
                   ;; for dialog-init
                     defaults-file
                     popup-keys
                     dist-keys
                     int-keys
                     toggle-keys
                     plain-string-keys
                     default-actions
                     dialog-ties
                     sub-dialogs
                     extra-keys
                     tile-actions
                     ;; local
                     info
                     job-dir
                     job-file
                     )
  "Edits the jobinfo file, job.dat"
  ;; only works as a descendant of a job folder
  (if (not (setq job-dir (find-job-dir)))
      (error "JOBINFO: Not in a job folder"))

  ;; add default job.dat if not present
  (setq job-file (strcat job-dir "/job.dat"))
  (if (not (member "job.dat" (vl-directory-files job-dir)))
      (vl-file-copy (strcat psc-src-dir "fab/default-job.dat")
                    job-file))

  ;; initialize the dialog
  (setq plain-string-keys '("number"
                            "name"
                            "location"
                            "customer")
        defaults-file job-file
        info (dialog-init "fab/jobinfo.dcl" "jobinfo" nil))

  ;; if user clicked save, rewrite the job file
  (cond ((and info
              (setq defaults-file (open defaults-file "w")))
         (foreach item info
                  (write-line (strcat (car item)
                                      ":"
                                      (cadr item))
                              defaults-file))
         (close defaults-file)))
  (princ))
(defun-r 'c:jobinfo)
