(psc-include
 '(
   "common-data.lsp"
   "dialog/dialog.lsp"
   "land/dialog.lsp"
   "land/derived.lsp"
   "land/migrations.lsp"
   "land/section.lsp"
   "shapes/shape.lsp"
   "3D/3d-land.lsp"
   ))

(defun-q c:landing ( /
                     source
                     error-out
                     all-are
                     tread_opts-keys
                     conn_opts-keys
                     chan_bolts-keys
                     )
  "Creates or edits landing blocks

To create a new landing from scratch, press ENTER at the selection prompt.

To create a new landing based on the properties of the two stairs that will connect to it,
select both stairs (and nothing else) at the prompt and pess ENTER.

To edit a single landing, select it at the prompt and press ENTER.

To edit multiple landings in bulk, select them all at the prompt and press ENTER."
  (defun error-out ()
    (error "LANDING: valid selections are: (1) landing, (2) stairs, OR multiple landings"))
  (defun all-are (app-id)
    (vl-every '(lambda (x) (= (app-id-equiv (cadr (assoc "app_id" (read-xdata x "")))) app-id))
              source))
  
  (setq source (get-stairland 'both T))
  (if source
      (cond ((> (length source) 2)
             (if (all-are "Land")
                 (land-multi-edit source)
                 (error-out)))
            ((= (length source) 2)
             (cond ((all-are "Land") (land-multi-edit source))
                   ((all-are "Stair") (land-single-edit source))
                   (T (error-out))))
            ((= (length source) 1)
             (if (all-are "Land")
                 (land-single-edit (car source))
                 (error-out))))
      (land-single-edit nil))
  (princ))
(defun-r 'c:landing)
