(defun-q c:mrotate (/
                    ss
                    rot-ang
                    ss-lst
                    i
                    len
                    )
  "Rotates multiple independent selection sets by the same angle

This command is mainly useful for saving keystrokes while rotating all the North arrows in
plan views. Usage:

1. Run MROTATE
2. Select an object or group of objects and a base point about which to rotate them
3. Repeat step 2 for each combination of selection set and base point
4. Move on from step 3 by pressing ENTER at \"Select objects:\" prompt
5. Input angle and press ENTER"
  (setq ss (ssget))
  (while (/= ss nil)
    (add-to-list 'ss-lst (list ss (getpoint "\nBase point: ")))
    (setq ss (ssget)))
  (setq rot-ang (getangle (cadr (last ss-lst)) "\nRotation: "))
  (foreach ss ss-lst
           (setq i -1
                 len (sslength (car ss)))
           (while (< (inc! 'i) len)
             (vla-Rotate (ename>vlobj (ssname (car ss) i)) (3dpt (cadr ss)) rot-ang)))
  (princ))
(defun-r 'c:mrotate)
  
