(psc-include
 '(
   "fab/stair.lsp"
   "land/util.lsp"
   "stair/util.lsp"
   ))

(defun-q c:qt-takeoff (/ ents stairs lands takeoff table row)
  "Creates and inserts a Quiet Tread takeoff table for stairs and landings"
  (setq ents (get-stairland 'both nil))
  (split-list ents '(= (xd-value "app_id" (read-xdata x "")) "Stair") 'stairs 'lands)
  (setq takeoff (append (map-append 'stair-qt-takeoff stairs)
                        (map-append '(lambda(l)
                                      (with-data (read-xdata l "Land")
                                        '((land-qt-takeoff))))
                                    lands))
        takeoff (vl-sort takeoff '(lambda(a b) (< (atoi (caar a)) (atoi (caar b)))))
        table (vla-AddTable modelSpace
                            (3dpt (getpoint "\nInsert: "))
                            (+ (length takeoff) 2)
                            5
                            6
                            1)
        row 2)
  (vla-put-RegenerateTableSuppressed table :vlax-true)
  (vla-SetText table 0 0 "QT Takeoff")
  
  (vla-SetText table 1 0 "Q#")
  (vla-SetColumnWidth table 0 12)
  (vla-SetText table 1 1 "Qty")
  (vla-SetColumnWidth table 1 12)
  (vla-SetText table 1 2 "Desc")
  (vla-SetColumnWidth table 2 48)
  (vla-SetText table 1 3 "Width")
  (vla-SetColumnWidth table 3 16)
  (vla-SetText table 1 4 "Length")
  (vla-SetColumnWidth table 4 16)
  (foreach q takeoff
           (vla-SetText table row 0 (strcat "QT" (caar q)))
           (vla-SetText table row 1 (to-string (cadr q)))
           (vla-SetText table row 2 "QUIET TREAD 1/8")
           (vla-SetText table row 3 (cadar q))
           (vla-SetText table row 4 (caddar q))
           (inc! 'row))
  (vla-put-RegenerateTableSuppressed table :vlax-false))
(defun-r 'c:qt-takeoff)
