  (psc-include '("rail/guard-rail.lsp" "rail/rail-section.lsp" "rail/stair-rail.lsp" "shapes/shape.lsp"))

  (defun-q c:rail-section ( / lst ins blk lbk ubk p-ent a-ent b-ent a-dat b-dat format)
    "Generates a rail section"
    (defun format ()
      (mapcar '(lambda (obj) (vla-put-layer obj "SOLID")) s-lst)
      (mapcar '(lambda (obj) (vla-put-layer obj "RAILS")) r-lst)
      (mapcar '(lambda (obj) (vla-put-layer obj "HIDDEN")) h-lst)
      (mapcar
       '(lambda (obj)
          (vlax-put-property obj "Layer" "TEXT")
          (vlax-put-property obj "StyleName" "Calibri")
        ) ;_ lambda
        t-lst
      ) ;_ mapcar
      (mapcar
       '(lambda (obj)
          (vlax-put-property obj "layer" "DIM")
          (vlax-put-property obj "TextStyle" "Calibri")
          (vlax-put-property obj "linearscalefactor" 0.5)
        ) ;_ lambda
        d-lst
      ) ;_ mapcar
    ) ;_ defun format
    (setup-env nil)
    (setq
      lst (get-stairland 'both T)
      ins (getpoint "\nIns: ")
      blk (p-blk nil)
      lbk (p-blk nil)
      ubk (p-blk nil)
      p-ent (car (filter lst '(read-xdata x "Land")))
      a-ent (car (filter lst '(read-xdata x "Stair")))
      b-ent (cadr (filter lst '(read-xdata x "Stair")))
      a-dat (if a-ent (read-xdata a-ent "Stair"))
      b-dat (if b-ent (read-xdata b-ent "Stair"))
    ) ;_ setq
    (if
      (or
        (> (length lst) 3)
        (> (length (filter lst '(read-xdata x "Land"))) 1)
        (> (length (filter lst '(read-xdata x "Stair"))) 2)
        (not (and a-ent b-ent))
      ) ;_ or
      (error
        "Section requires
        EXACTLY two stair blocks and
        OPTIONALLY one landing block"
      ) ;_ error
    ) ;_ if
    (with-data
      (append
        (mapcar
         '(lambda (l) (subst (strcat "a-flt_" (car l)) (car l) l))
          a-dat
        ) ;_ mapcar
        (mapcar
         '(lambda (l) (subst (strcat "b-flt_" (car l)) (car l) l))
          b-dat
        ) ;_ mapcar
        (mapcar 'list
          (list "a-gap" "b-gap")
          (if p-ent
            (with-data
              (append (read-xdata p-ent "") (read-xdata a-ent ""))
             '( (if
                  (member (list dir z_pos) '((-1 "Near") (1 "Far")))
                  (list left_gap right_gap)
                  (list right_gap left_gap)
              ) ) ;_ if
            ) ;_ with-data
            (mapcar
             '(lambda (dat txt)
                (if (= "Wall Rail" (xd-value "o-rail_type" dat))
                  (getreal txt)
                  0.0
                ) ;_ if
              ) ;_ lambda
              (list a-dat b-dat) '("\n'A' Gap: " "\n'B' Gap: ")
            ) ;_ mapcar
          ) ;_ if
        ) ;_ mapcar
      ) ;_ append
     '(
        (rail-section-a-flight) ;;; A-FLIGHT
        (rail-section-b-flight) ;;; B-FLIGHT
        (rail-section-dims) ;;; DIMENSIONS

        ( (lambda (inc wid) ;;; GUARD BTWN
            (if (and inc (> wid 2.75)) (rail-section-g-btwn wid))
          ) ;_ lambda
          (= "Stair Rail" a-flt_i-rail_type b-flt_i-rail_type)
          (apply '+
            (cons
              a-flt_dist_btwn
              (mapcar
               '(lambda (m) (* -1.5 (abs (1- (atoi m)))))
                (list a-flt_i-rail_topmnt b-flt_i-rail_topmnt)
              ) ;_ mapcar
            ) ;_ cons
          ) ;_ apply
        ) ;_ lambda-func

        (setq lbk (insert-block blk (list (- (/ a-flt_dist_btwn 2.0)) 0) lbk))
        (if (member (list a-flt_dir a-flt_z_pos) '((-1 "Near") (1 "Far")))
          (setq lbk (mirror&delete lbk '(0 0) 'Y))
        ) ;_ if

        (setq ubk (insert-block blk (list (- (/ a-flt_dist_btwn 2.0)) 0) ubk))
        (if (member (list b-flt_dir b-flt_z_pos) '((1 "Near") (-1 "Far")))
          (setq ubk (mirror&delete ubk '(0 0) 'Y))
        ) ;_ if

      )
    ) ;_ with-data

    (setq blk (insert-block modelspace ins blk))
    (mapcar
     '(lambda (p) (vlax-put-property blk p 2.0))
     '("XScaleFactor" "YScaleFactor" "ZScaleFactor")
    ) ;_ mapcar
    (vla-explode lbk)
    (vla-delete lbk)
    (vla-explode ubk)
    (vla-delete ubk)
    (vla-explode blk)
    (vla-delete blk)

  ) ;_ defun-q c:rail-section
  (defun-r 'c:rail-section)
