;; command to draw rail blocks at stairs (landings in future)

(psc-include
 '(
   "rail/stair-rail.lsp"
   "rail/guard-rail.lsp"
   "rail/wall-rail.lsp"
   "rail/return.lsp"
   ))

(defun-q c:rails (/
                  enames
                  kword
                  kwords
                  i
                  next
                  side
                  dispatch
                  )
  "Draws rail blocks at stair main sections

This command will draw stair rails, guard rails, wall rails, and handgrab returns at all
selected stairs. Returns are only drawn between two flights, so the last flight won't have
a return added, even if it should get one.

This command can be used to draw either the inside or outside rails for each flight."
  ;; call appropriate draw function
  (defun dispatch (ename next / ins rail-type)
    (with-data (draw-xdata-migrate 'ename "Stair")
      '((setq ins (cdr (assoc 10 (entget ename)))
              rail-type (sidekey-rail "type"))
        (if (/= rail-type "None")
            (if (wcmatch rail-type "*Stair*")
                (progn
                  (draw-stair-rail ins side)
                  ;; draw guard rails at haunches
                  (draw-stair-guard-rails ins side)
                  ;; draw returns at inside rails
                  (if (and (= side "i") next)
                      (draw-hg-return ename next)))
              (draw-wall-rail-2d ins side))))))

  (setq kwords '("Inside" "Outside"))
  (initget 0 (strjoin kwords " "))
  (setq kword (getkword (strcat "\nRail to draw [Inside/Outside] <Inside>: "))
        side (if kword (lowercase (substr kword 1 1)) "i"))
  (setq enames (get-stairland 'stair T))
  (mapcar 'dispatch enames (append (cdr enames) '(nil)))
  (princ))
(defun-r 'c:rails)
