(setq *shape-line-name* "W10x12")

(defun-q c:shape-line (/ name pt1 pt2 ang endpts)
  "Draws a line representing a beam in 'schematic' plan view

This command draws a 3 inch thick polyline with a label, for use in RO plan views."
  (setq name (getstring (strcat "\nName <" *shape-line-name* ">: "))
        pt1 (getpoint "\nPoint 1: ")
        pt2 (getpoint pt1 "\nPoint 2: ")
        ang (angle pt1 pt2)
        endpts (vl-sort (list (polar pt1 ang 4)
                              (polar pt2 (angle pt2 pt1) 4))
                        (sort-by 'car '<))
        ang (apply 'angle endpts)
        text-ins (polar (apply 'mid-2-pts endpts)
                        (+ (dtr 90) ang)
                        4))
  (if (= name "")
      (setq name *shape-line-name*)
      (setq *shape-line-name* name))
  (if (> ang pi)
      (setq ang (- ang (* 2 pi))))
  ((lambda(/ pl)
     (setq pl (add-polyline modelSpace '(0 0) endpts nil))
     (vla-put-Layer pl "OBJ")
     (vla-SetWidth pl 0 3 3)))
  ((lambda(/ mt)
     (setq mt (add-mtext modelSpace
                         text-ins
                         (strcat name " (B/O)")
                         (apply 'distance endpts)
                         'bottomcenter))
     (vla-put-Rotation mt ang)
     (vla-put-Layer mt "TEXT")))
  (princ))
(defun-r 'c:shape-line)
  
