(defun-q c:shape-text (/ shape shape-ins str obj)
  "Draws a text label for a DRAWSHAPE section block

Running this command and selecting a section block that was created using DRAWSHAPE will
put a text label on your cursor for inserting in an RO section view."
  (setq shape (car (entsel "\nSelect section block: ")))
  (if (not shape) (error "No shape selected"))
  (setq shape-ins (cdr (assoc 10 (entget shape)))
        shape (read-xdata shape "Shape")
        str (strcat (string-subst-all "x" "X" (xd-value "name" shape)) " (B/O)")
        obj (add-mtext modelSpace shape-ins str 12 'topcenter))
  (vla-put-Layer obj "TEXT")
  (setvar 'cmdecho 0)
  (command "move" (entlast) "" shape-ins)
  (setvar 'cmdecho 1)
  (princ))
(defun-r 'c:shape-text)
