(psc-include
 '(
   "common-data.lsp"
   "dialog/dialog.lsp"
   "shapes/shape.lsp"
   "stair/dialog.lsp"
   "stair/derived.lsp"
   "stair/details.lsp"
   "stair/migrations.lsp"
   "stair/section.lsp"
   "3D/3d-stair.lsp"
   "stair/stringer.lsp"
   "stair/tread.lsp"
   ))

(defun-q c:stair ( / stair-data
                     source
                     app-id
                     delta
                     tread_opts-keys
                     conn_opts-keys
                     rail_opts-keys
                     rail_opts-dist-keys
                     rail-types
                     rot)
  "Creates or edits stair blocks

To create a new stair, press ENTER at the selection prompt.

To edit a single star, select it at the prompt and press ENTER.

To edit multiple stairs in bulk, select them all at the prompt and press ENTER."

  (setq source (get-stairland 'stair nil))
  (if (= (length source) 1)
    (setq
      source (car source)
      app-id (cadr (assoc "app_id" (read-xdata source "")))
      rot (vla-get-rotation (ename>vlobj source))
    ) ;_ setq
  ) ;_ if

  ;; load linetypes, layers and textstyles
  (setup-env (= app-id "3D_Stair"))

  (if (not (= (type source) 'LIST))
    (if
      (setq stair-data
        (stair-dialog-init
          (cond
            ( (null source) nil)
            ( (= T) (draw-xdata-migrate 'source app-id))
          ) ;_ cond
        ) ;_ stair-dialog-init
      ) ;_ setq
      ((if (= app-id "3D_Stair") draw-3d_stair draw-stair)
        stair-data
        (cond
          ( (null source) (getpoint "\nStair Insertion Point: "))
          ( (= T) (get-ins-and-delete source))
        ) ;_ cond
      ) ;_ draw-stair -or- draw-3d_stair
    ) ;_ if

    ;; multi-stair
    (if (setq delta (stair-multi-dialog-init))
      (stair-multi-edit source delta)
    ) ;_ if

  ) ;_ if
  (princ))
(defun-r 'c:stair)
