(defun-q c:topviewhandgrab (/ pline pts)
  "Formats a polyline as a pipe handgrab in plan view

To use, draw a polyline, run TOPVIEWHANDGRAB, select the polyline you drew, and press
ENTER. It will be thickened to 1.66 inches, put on RAILS layer, set to color 140, and
given an outline on the NO PLOT layer. A 2.33 inch radius fillet will be applied to all
points, so this command will fail if the fillet cannot be applied because the points are
too close together."
  (setq pline (ename>vlobj (car (entsel)))
        pts (get-vlist pline))
  (if (> (length pts) 1)
      (progn
        (vla-Delete pline)
        (setq pline (add-polyline modelSpace '(0 0 0) (fillet-all-pts pts 2.33) nil))))
  (vla-put-Layer pline "RAILS")
  (vla-put-ConstantWidth pline 1.66)
  (vla-put-Color pline 140)
  (setq pline (offset&close pline 0.83 T nil))
  (vla-put-Layer pline "NO PLOT")
  (vla-put-Color pline 140)
  (vla-put-ConstantWidth pline 0)
  (princ))
(defun-r 'c:topviewhandgrab)
