(defun-q c:trimrows ( / cell table)
  "Trims empty rows from a fab drawing table

A row is considered empty if its first column is blank.

If inserting rows in the material list above an existing standard-prefix part (e.g. AA;
i.e. not pans, STN, QT, or NRT), the mark numbers for parts below will be increased by the
number of rows added. This carries to the callouts in the drawing as well.

If trimming rows in the assembly table, the quantities in the material table will be
updated."
  (setq cell (get-table-cell))
  (if (not cell)
      (error "No table cell selected"))
  (setq table (pop! 'cell))
  (table-trim-empty-rows table (car cell))
  (princ))
(defun-r 'c:trimrows)
