(defun-q c:updatemarkno (/ table row prefix string)
  "Updates a single material list mark number in a fab drawing"
  (setq table (get-table-by-title "Material"))
  (if (not table)
      (error "No material table found"))
  (setq row 2
        prefix (vl-string-right-trim "0123456789" (vla-GetText table row 0))
        from (strcat prefix (to-string (getint "\nFrom: ")))
        to (strcat prefix (to-string (getint "\nTo: "))))
  ;; update material table entry manually
  (while (/= (setq string (vla-GetText table row 0)) from)
    (inc! 'row))
  (if (= string from)
      (vla-SetText table row 0 to))
  (vla-replace-string modelspace from to)
  (vla-Regen acadDoc acAllViewPorts))
(defun-r 'c:updatemarkno)
