(psc-include '("dialog/dialog.lsp"))

(defun-q c:xdatalist ( /
                       xdatalist-init
                       ename
                       )
  "Displays the raw XDATA for an object in a list box"
  (defun xdatalist-init (ename /
                             appids
                             datalsts
                             datalst
                             ret
                             update-datalst
                             ;; variables defined here for dialog-init
                             defaults-file
                             popup-keys
                             dist-keys
                             int-keys
                             toggle-keys
                             plain-string-keys
                             default-actions
                             dialog-ties
                             sub-dialogs
                             ;; hook
                             dialog-after-load
                             dialog-save-action
                             ;; variables included here for scope,
                             ;; but not defined here directly
                             extra-keys
                             tile-actions
                             )
  (setq popup-keys '(("appid" . appids)
                     ("data" . update-datalst))
        appids (mapcar 'car (cdr (assoc -3 (entget ename '("*"))))))

  (if (not appids)
      (error "XDATALIST: item has no XDATA"))

  ;; compile the data for each AppID so we don't have to keep reading
  ;; the ent every time a user interacts with the appid popup
  (foreach appid appids
     (add-to-list 'datalsts
                  (cons appid (read-xdata ename appid))))
  
  (defun update-datalst ( / last-key derived-start i base-keys derived-keys)
    (setq datalst (cdr (assoc (dialog-popup-val "appid") datalsts))
          i 0)
    (mapcar! '(lambda (x / ret)
                (if (< (car x) last-key)
                    (setq derived-start i))
                (setq ret (strcat (car x) "\t" (to-string (cadr x)))
                      last-key (car x)
                      i (1+ i))
                ret)
             'datalst)
    (split-list-n datalst derived-start 'base-keys 'derived-keys)
    (append base-keys
            (cons "BEGIN DERIVED KEYS\t------------------" derived-keys)))

  (defun dialog-after-load ( / )
    (dialog-add-action "appid" '(dialog-popup-list-update "data")))

  ;; return the selected AppID and data element from the dialog
  (defun dialog-save-action ( / )
    (setq ret (cons (dialog-popup-val "appid")
                    (strsplit (nth (atoi (get_tile "data")) datalst) "\t")))
    (done_dialog 0))

  (dialog-init "xdatalist.dcl" "xdatalist" source)
  ret)

  (setq ename (car (entsel "Select: ")))
  (xdatalist-init ename)
  (princ))
(defun-r 'c:xdatalist)



