;; Common data structures and tile actions

(setq stringers '("PL1/4x10"
                  "PL3/8x10"
                  "PL1/2x10"
                  "PL1/4x12"
                  "PL3/8x12"
                  "PL1/2x12"
                  "MC10x8.4"
                  "MC10x22"
                  "MC12x10.6"
                  "MC12x14.3"
                  "MC12x31"
                  "MC18x42.7"
                  "C10x15.3"
                  "C10x20"
                  "C12x20.7"
                  "C12x30"
                  "C15x33.9")
      finishes '("Bare metal, no finish"
                 "Rodda Barrier III Red Oxide"
                 "Rodda Barrier III Black"
                 "Rodda Barrier III Grey"
                 "Rodda Barrier III High Solids Red Oxide"
                 "Rodda Barrier III High Solids Black"
                 "Rodda Barrier III High Solids Grey"
                 "Two coats Rodda Barrier III Red Oxide"
                 "Two coats Rodda Barrier III Black"
                 "Two coats Rodda Barrier III Grey"
                 "Two coats Rodda Barrier III High Solids Red Oxide"
                 "Two coats Rodda Barrier III High Solids Black"
                 "Two coats Rodda Barrier III High Solids Grey"
                 "Galvanized"
                 "Custom")
      rail-styles '("100 2-Line Pipe"
                    "200 6-Line Pipe"
                    "300 Rec Tube"
                    "400 Picket"
                    ;; "500 Mesh"
                    ;; "600 Cable"
                    ;; "700 Round Rod"
                    ;; "800 Glass"
                    )
      bent-plates '("14ga"
                    "12ga"
                    "3/16"
                    "1/4")
      exp-anchors '("5/8 DIA. x 4 3/4"
                    "5/8 DIA. x 6"
                    "3/4 DIA. x 5 1/2"
                    "3/4 DIA. x 7")
      tc-bolts '("5/8 DIA. x 1 1/2"
                 "5/8 DIA. x 2"
                 "3/4 DIA. x 1 1/2"
                 "3/4 DIA. x 2")
      channels '("C6x8.2"
                 "C6x10.5"
                 "C8x11.5"
                 "C8x13.75"
                 "C10x15.3"
                 "C10x20"
                 "C12x20.7"
                 "C12x25"))

;; force key to be uppercase
(defun force-uppercase (key value / )
  (set_tile key (uppercase value)))

;; set stair-all-keys global variable
((lambda(/
         ;; variables defined here for dialog-init
         defaults-file
         popup-keys
         popup-keys-strings
         dist-keys
         int-keys
         toggle-keys
         plain-string-keys
         edit-box-keys
         string-keys
         all-keys
         default-actions
         dialog-ties
         sub-dialogs
         tread_opts-keys
         tread_opts-popup-keys
         tread_opts-dist-keys
         tread_opts-toggle-keys
         conn_opts-keys
         conn_opts-popup-keys
         conn_opts-dist-keys
         rail_opts-popup-keys
         rail_opts-toggle-keys
         ;; variables included here for scope,
         ;; but not defined here directly
         extra-keys
         tile-actions
         tread_opts-val
         conn_opts-val
         ;; tile actions
         height_f2f-action
         risers_level-action
         tread_style-action
         conn-action
         ;; init functions for sub-dialogs
         tread_opts-sub-init
         conn_opts-sub-init
         rail_opts-sub-init
         ;; hooks
         dialog-after-load
         dialog-before-save
         ;; local variables
         cur-stn-styles
         cur-tread-mats
         ;; stair definition variables
         top-details
         top-details-strings
         bot-details
         bot-details-strings
         4x-angles
         )
   (psc-include '("stair/dialog.lsp"))
   (stair-dialog-load-common-defs)
   (setq *stair-all-keys* (append (mapcar 'car popup-keys)
                                  dist-keys
                                  int-keys
                                  plain-string-keys
                                  toggle-keys
                                  conn_opts-keys
                                  tread_opts-keys
                                  rail_opts-keys))))
