  (set-file-docstring "Function for drawing embeds")

  (defun-q draw-embed (dat ins / em4-studs blk lay pts ret rev)
    "Function to draw 2D embed block"
    (setq blk (p-blk (uppercase (xd-value "style" dat))))
    (defun em4-studs (pt)
      (add-polyline
        blk
        pt
       '((-0.25 0.0) (-0.25 3.625) (-0.5 3.625) (-0.5 4.0)
         (0.5 4.0) (0.5 3.625) (0.25 3.625) (0.25 0.0))
        T
      ) ;_ add-polyline
    ) ;_ defun em4-studs
    (setq
      lay (getvar 'clayer)
      rev (if (<= (/ pi 1.99999) rot (* pi 1.5) ) pi 0)
      pts (cond
            ( (= style "em-1") (list t_lng 3.0))
            ( (= style "em-4") '(10.0 0.25))
            ( (= style "em-5") '(6.0 6.0))
            ( (= T) (list t_lng 4.0))
          ) ;_ cond
    ) ;_ setq
    (set-active-layer (if (= style "em-3") "Hidden" "OBJ"))
    (apply 'add-rectangle (append (list blk) pts '((0 0))))
    (if (= style "em-4")
      (mapcar 'em4-studs '((1.5 0.25) (5.0 0.25) (8.5 0.25)))
    ) ;_ if
    (set-active-layer "Hidden")
    (if (member style '("em-1" "em-2" "em-3"))
      (add-polyline
        blk
       '(0 0)
        (mapcar 'list
          (list 0.0 (car pts))
          (lst* (if (= style "em-3") 0.375 0.25) 2)
        ) ;_ mapcar
        nil
      ) ;_ add-polyline
    ) ;_ if
    (set-active-textstyle "Calibri")
    (set-active-layer "No Plot")
    (add-to-list 'ret
      (add-text
        blk
        (list ((if (= 0 rev) + -) (/ (car pts) 2.0) 15) -5.5)
        (strcat "(" (itoa qty) ")")
        5.5
        0.5
        'MiddleCenter
      ) ;_ add-text
    ) ;_ add-to-list
    (if (= hide "0") (set-active-layer "Rails"))
    (add-to-list 'ret
      (add-text
        blk
        (list (/ (car pts) 2.0) -5.5)
        (uppercase style)
        5.5
        0.5
        'MiddleCenter
      ) ;_ add-text
    ) ;_ add-to-list
    (mapcar '(lambda (obj) (vla-put-rotation obj rev)) ret)
    (add-rectangle blk 18 8 (list (- (/ (car pts) 2.0) 9.0) -9.5))
    (set-active-layer "OBJ")
    (setq blk (insert-block modelSpace ins blk))
    (assign-xdata blk "Embed" (format-xdata dat))
    (set-active-layer lay)
    blk
  ) ;_ defun-q draw-embed
  (defun-r 'draw-embed)

  (defun-q single-embed ()
    "Processes to draw single embed"
    (setup-env (= app "3D_Embed"))
    (setq embed-dat-val dat)
    (if ent (setq rot (vla-get-rotation (ename>vlobj ent))))
    (setq obj
      ( (if (= app "3D_Embed") draw-3d_embed draw-embed)
        data
        (if ent
          (get-ins-and-delete ent)
          (getpoint "\nInsertion Point: ")
        ) ;_ if
      ) ;_ draw-embed -or- draw-3d_embed
    ) ;_ setq
    (if rot (vla-put-rotation obj rot))
    (vlobj>ename obj)
  ) ;_ defun-q single-embed
  (defun-r 'single-embed)

  (defun-q multi-embed (delta)
    "Passes data from multiple embeds to single embed process"
    (if (remove! 'delta '(null (cadr x)))
      (mapcar
       '(lambda (ent / )
          (setq
            dat (read-xdata ent "")
            app (xd-value "app_id" dat)
          ) ;_ setq
          (map-apply
           '(lambda (k v)
              (if (assoc k dat)
                (subst-key! k v 'dat)
                (append! 'dat (list (list k v)))
              ) ;_ if
            ) ;_ lambda
            delta
          ) ;_ map-apply
          (if (= "em-1" (xd-value "style" delta))
            (subst-key! "t_lng"
              (apply '+
                (mapcar
                 '(lambda (key) (?n (xd-value key dat)))
                 '("l_gap" "l_str" "d_btw" "r_str" "r_gap")
                ) ;_ mapcar
              ) ;_ apply
             'dat
            ) ;_ subst-key
          ) ;_ if
          (with-data dat '((single-embed)))
        ) ;_ lambda
        sel
      ) ;_ mapcar
    ) ;_ if
  ) ;_ defun-q single-embed
  (defun-r 'multi-embed)
