(psc-include '("stair/stringer.lsp"
               "stair/tread.lsp"))

(defun make-laser-stringer-files (datas / path)
  (setq path (vla-get-Path acadDoc))
  (if (not (member "Laser" (vl-directory-files path)))
      (vl-mkdir (strcat path "/Laser")))
  (foreach data datas
           (foreach side '("l" "r")
                    (if (begins-with (xd-value (strcat side "-string_mat") data) "PL")
                        (with-data data '((make-laser-stringer-file side)))))))

(defun make-laser-stringer-file (side / file mspc pts nosings mark filename)
  (setq file (vla-Add (vla-get-Documents acadObj)
                      (strcat psc-src-dir "fab/laser.dwt"))
        mspc (vla-get-ModelSpace file)
        pts (cdr (assoc 'string-outline (stair-stringer-calc side)))
        nosings (mapcar '(lambda(pt) (list (abs (car pt))
                                           (cadr pt)))
                        (calc-nose-pts))
        nosings (list (car nosings) (last nosings))
        mark (strcat assembly "-" (uppercase side))
        filename (strcat path
                         "/Laser/"
                         (vl-string-subst "_" "/" (frac (sidekey "string_wid")))
                         "-"
                         mark))
  (if (= side "r")
      (setq nosings (mirror-pts-v nosings 0)
            pts (mirror-pts-v pts 0)))
  (vla-put-Layer (add-polyline mspc '(0 0 0) pts T) "CUT")
  (mapcar '(lambda(pt) (vla-put-Layer (vla-AddCircle mspc (3dpt pt) 0.125) "ETCHING_MARKING"))
          nosings)
  (vla-put-StyleName
   (vla-put-Layer-r
    (add-mtext mspc (displace-pt (car nosings) '(0 -1)) mark 1 (if (= side "r") 'topright 'topleft))
    "ETCHING_MARKING")
   "STANDARD")
  (vla-SaveAs file filename)
  (vla-Close file))
