
  (psc-include '("land/util.lsp"))

  (defun draw-land (data ins / blockObj d-chn d-plt d-txt d-clr)
    (setq blockobj (p-blk (xd-value "assembly" data)))
    (setup-env nil)

    ;;; draw landing channels
    (defun d-chn ( / tmp)
      (mapcar
       '(lambda (obj)
          (vla-put-Layer obj "OBJ")
          (if (= side "Left") (mirror&delete obj '(0 0) 'Y) obj)
        ) ;_ lambda
        (list
          (add-shape blockObj (list 0 (- flr_thick)) front_chan)
          (progn
            (setq tmp
              (add-shape
                blockObj
                (list back_chan_loc (- flr_thick))
                back_chan
              ) ;_ add-shape
            ) ;_ setq
            (if (= flip_back "1")
              (mirror&delete tmp (list back_chan_loc 0) 'Y)
              tmp
            ) ;_ if
          ) ;_ progn
        ) ;_ list
      ) ;_ mapcar
    ) ;_ defun d-chn

    ;;; draw landing platform
    (defun d-plt ()
      (mapcar '(lambda (obj) (if (= side "Left") (mirror&delete obj '(0 0) 'Y) obj))
              (cond
               ;;;;;;;;;;;
               ;; Pan-fill
               ;;;;;;;;;;;
               ((begins-with tread_style "100")
                (append
                 (list
                  ;; top of decking
                  (vla-put-layer-r
                   (add-polyline blockObj
                                 '(0 0)
                                 (append
                                  '((0.25 -3.5 0) (0.25 -2.0 0))
                                  (if (= "None" back_bolt_to)
                                      (list (list (- plt_dpt 0.1345) -2.0 0))
                                      (mapcar
                                       '(lambda (y) (list (- plt_dpt 0.25) y 0))
                                       '(-2.0 -3.5))))
                                 nil)
                   "HIDDEN")
                  ;; concrete fill
                  (vla-put-color-r
                   (vla-put-layer-r
                    (add-polyline blockObj
                                  '(0 0)
                                  (append
                                   '((0.0 -3.5 0) (0.0 0.0 0))
                                   (if (= "None" back_bolt_to)
                                       (list (list (- plt_dpt 0.75) 0.0 0))
                                       (list (list plt_dpt 0 0) (list plt_dpt -3.5 0))))
                                  nil)
                    "SOLID")
                   252)
                  ;; bottom of decking
                  (vla-put-layer-r
                   (add-polyline blockObj
                                 '(0 0)
                                 (mapcar 'cons
                                         (list 0.0
                                               (- plt_dpt (if (= "None" back_bolt_to) 3.5 0.0)))
                                         '((-3.5 0.0) (-3.5 0.0)))
                                 nil)
                   "SOLID"))
                 ;; back edge form
                 (if (= "None" back_bolt_to)
                     (list
                      (vla-put-layer-r
                       (offset&close (add-polyline blockObj
                                                   (list plt_dpt 0)
                                                   '((-0.75 0 0) (0 0 0) (0 -3.5 0) (-3.5 -3.5 0))
                                                   nil)
                                     0.1345
                                     nil
                                     0)
                       "SOLID")))))

               ;;;;;;;;;;;;;;;;
               ;; Checker plate
               ;;;;;;;;;;;;;;;;
               ((begins-with tread_style "200")
                (append
                 ;; quiet tread
                 (if (= quiet_tread "1")
                   (mapcar
                    '(lambda (lst)
                       (vla-put-layer-r
                         (with-data (cadr lst)
                          '((add-rectangle blockObj lng (- chk_thk) (list off hgt)))
                         ) ;_ with-data
                         "RAILS"
                       ) ;_ vla-put-layer-r
                     ) ;_ lambda
                     (calc-qtread-spacing)
                   ) ;_ mapcar
                 ) ;_ if
                 (list
                  ;; checker plate
                  (vla-put-layer-r
                   (add-rectangle blockObj
                                  (- plt_dpt
                                     (if (= front_bolt_to "None") 0 chk_hold)
                                     (cond
                                      ((vl-string-search "Stair" back_bolt_to) chk_hold)
                                      ((vl-string-search "Land" back_bolt_to) (- chk_hold))
                                      (T 0)))
                                  (- chk_thk)
                                  (list (if (= front_bolt_to "None") 0 chk_hold) 0))
                   "HATCH"))
                 ;; cans
                 ((lambda(/ front-x len rect)
                    (setq front-x (cond ((= finish "Galvanized") 0)
                                        ((= front_bolt_to "None") 0.25)
                                        (T 1.5))
                          len (- plt_dpt
                                 front-x
                                 (cond ((vl-string-search "Stair" back_bolt_to)
                                        (if (= finish "Galvanized") 0 1.5))
                                       ((= back_bolt_to "Landing Channel") 0)
                                       ((= back_bolt_to "None") 0.25)))
                          rect (vla-put-layer-r (add-rectangle blockObj
                                                               len
                                                               (- (- flr_thick chk_thk))
                                                               (list front-x (- chk_thk)))
                                                "SOLID"))
                    (if (= finish "Galvanized")
                        (list (vla-put-layer-r (add-polyline blockObj
                                                             (list front-x -0.325)
                                                             (list '(0 0 0)
                                                                   (list len 0 0))
                                                             nil)
                                               "HIDDEN")
                              rect)
                        (list rect))))
                 ;; front tube
                 (if (and (/= front_bolt_to "None")
                          (/= finish "Galvanized"))
                     (mapcar '(lambda(x) (vla-put-layer-r x "HATCH"))
                             (add-shape blockObj (list 0.75 (- chk_thk)) "HSS2.5x1.5x0.065")))
                 ;; back tube
                 (if (and (vl-string-search "Stair" back_bolt_to)
                          (/= finish "Galvanized"))
                     (mapcar '(lambda(x) (vla-put-layer-r x "HATCH"))
                             (add-shape blockObj
                                        (list (- plt_dpt 0.75) (- chk_thk))
                                        "HSS2.5x1.5x0.065")))))
               ;;;;;;;;;;;;;;
               ;; Placeholder
               ;;;;;;;;;;;;;;
               (T (list
                   (vla-put-layer-r
                    (add-rectangle blockObj plt_dpt (- flr_thick) '(0 0))
                    "SOLID"))))))

    ;;; draw landing text
    (defun d-txt ( / obj)
      (setq obj (vla-AddText blockObj assembly (3dpt '(0 0 0)) 4.5))
      (mapcar
       '(lambda (pro val) (vlax-put-property obj pro val))
       '(layer stylename alignment scalefactor)
        (list "TEXT" "Calibri" acAlignmentMiddleCenter 0.8)
      ) ;_ mapcar
      (vla-Move obj (3dpt '(0 0)) (3dpt (list (/ plt_dpt 2.0) 5.0)))
      (if (= side "Left") (mirror&delete obj '(0 0) 'Y) obj)
    ) ;_ defun d-txt

    ;;; draw landing head clear line
    (defun d-clr ( / obj)
      (if (> head_clr 0.0)
        (progn
          (setq obj
            (add-polyline
              blockObj
              (list 0 head_clr 0)
              (list '(0 0 0) (list plt_dpt 0 0))
              nil
            ) ;_ add-polyline
          ) ;_ setq
          (vla-put-Color obj 252)
          (vla-put-Linetype obj "HIDDEN2")
          (if (= side "Left") (mirror&delete obj '(0 0) 'Y) obj)
        ) ;_ progn
      ) ;_ if
    ) ;_ defun d-clr

    ;; draw bolt centerlines
    (defun d-ctr (/ addline front_l-chan_vbolt back_l-chan_vbolt)
      (defun addline (y x / obj)
        (setq
          obj
          (add-polyline
            blockObj
            (list x (- y) 0)
           '((-1 0 0) (1 0 0))
            nil
          ) ;_ add-polyline
        ) ;_ setq
        (vla-put-Layer obj "NO PLOT")
        (if (= side "Left") (vla-mirror-y obj))
      ) ;_ defun addline
      (setq
        front_l-chan_vbolt (vl-string-search "Land" front_bolt_to)
        front_l-chan_vbolt (if front_l-chan_vbolt (+ flr_thick 4.0))
        back_l-chan_vbolt (vl-string-search "Land" back_bolt_to)
        back_l-chan_vbolt (if back_l-chan_vbolt (+ flr_thick 4.0))
      ) ;_ setq
      (foreach x
        (list
          (list front_l-stair_vbolt 0)
          (list front_r-stair_vbolt 0)
          (list front_l-chan_vbolt 0)
          (list back_l-stair_vbolt back_chan_loc)
          (list back_r-stair_vbolt back_chan_loc)
          (list back_l-chan_vbolt back_chan_loc)
        ) ;_ list
        (if (car x) (apply 'addline x))
      ) ;_ foreach
    ) ;_ defun d-ctr

    (with-data data '((d-chn) (d-plt) (d-txt) (d-clr) (d-ctr)))
    
    ;;; insert block
    (setq blockObj (insert-block modelSpace ins blockObj))
    (vla-put-Layer blockObj "LAND")
    (assign-xdata blockObj "Land" (format-xdata data))
    (setvar 'cmdecho 0)
    (command "DRAWORDER" (entlast) "" "b")
    (setvar 'cmdecho 1)
    (vlobj>ename blockObj)

  ) ;_ defun  draw-land
