(defun draw-land-top-view (data ins /
                                blockOffset
                                blockObj
                                obj
                                clayer
                                textstyle
                                mirror
                                som
                                tv-land-bolt
                                fchany
                                bchany
                                frtexty
                                tmp
                                )
  (setq blockOffset ((if (= side "Left") + -) center_offset)
        blocks (vla-get-Blocks acadDoc)
        blockObj (vla-Add blocks (3dpt 0 blockOffset 0) (p-blk-name (xd-value "assembly" data)))
        clayer (getvar 'clayer)
        textstyle (getvar 'textstyle))

  (defun mirror (obj)
    (if (= side "Left")
        (progn
          (vla-mirror-x obj)
          (vla-mirror-y obj))))
  ;; setq obj, mirror
  (defun som (new-obj)
    (setq obj new-obj)
    (mirror obj))

  ;; draw bolt holes
  (defun tv-land-bolt ( / fl-bolt-cen fr-bolt-cen bl-bolt-cen br-bolt-cen)
    (if front_l-stair_hbolt
        (progn
          (setq fl-bolt-cen (list front_l-stair_hbolt
                                  (- front_l-stair_wid front_l-stair_hbolt)))
          (if front_l-stair_hbolt2
              (append! 'fl-bolt-cen
                       (mapcar '+
                               fl-bolt-cen
                               (list front_l-stair_hbolt2 (- front_l-stair_hbolt2)))))
          (mapcar! '(lambda (y)
                     (list (list 0 (- (/ plt_wid 2) y) 0) dir))
                   'fl-bolt-cen)))

    (if front_r-stair_hbolt
        (progn
          (setq fr-bolt-cen (list front_r-stair_hbolt
                                  (- front_r-stair_wid front_r-stair_hbolt)))
          (if front_r-stair_hbolt2
              (append! 'fr-bolt-cen
                       (mapcar '+
                               fr-bolt-cen
                               (list front_r-stair_hbolt2 (- front_r-stair_hbolt2)))))
          (mapcar! '(lambda (y)
                     (list (list 0 (+ (/ plt_wid -2) y) 0) dir))
                   'fr-bolt-cen)))

    (if back_l-stair_hbolt
        (progn
          (setq bl-bolt-cen (list back_l-stair_hbolt
                                  (- back_l-stair_wid back_l-stair_hbolt)))
          (if back_l-stair_hbolt2
              (append! 'bl-bolt-cen
                       (mapcar '+
                               bl-bolt-cen
                               (list back_l-stair_hbolt2 (- back_l-stair_hbolt2)))))
          (mapcar! '(lambda (y)
                     (list (list back_chan_loc (- (/ plt_wid 2) y) 0) (- dir)))
                   'bl-bolt-cen)))

    (if back_r-stair_hbolt
        (progn
          (setq br-bolt-cen (list back_r-stair_hbolt
                                  (- back_r-stair_wid back_r-stair_hbolt)))
          (if back_r-stair_hbolt2
              (append! 'br-bolt-cen
                       (mapcar '+
                               br-bolt-cen
                               (list back_r-stair_hbolt2 (- back_r-stair_hbolt2)))))
          (mapcar! '(lambda (y)
                     (list (list back_chan_loc (+ (/ plt_wid -2) y) 0) (- dir)))
                   'br-bolt-cen)))

    (mapcar '(lambda (v)
              (som
               (vla-put-layer-r
                (add-polyline blockobj
                              (car v)
                              (list '(0 0 0) (list (* dir (cadr v)) 0 0))
                              nil)
                "center")))
            (append fl-bolt-cen fr-bolt-cen bl-bolt-cen br-bolt-cen)))

  ;;;;;;;;;;;;;;;;;;;
  ;; landing supports
  ;;;;;;;;;;;;;;;;;;;
  (draw-land-support 'tv)

  ;;;;;;;;;;;;;
  ;; bolt holes
  ;;;;;;;;;;;;;
  (tv-land-bolt)

  ;;;;;;;;;;;;;;;;
  ;; front channel
  ;;;;;;;;;;;;;;;;
  (setvar 'clayer "OBJ")
  (setq fchany (- 0
                  (/ plt_wid 2.0)
                  fr_ext
                  (if (and right_chan
                           (<= fr_ext br_ext))
                      (- right_chan_wid)
                    0)))
  (som (add-rectangle blockObj
                      front_chan_wid
                      front_chan_len
                      (list 0 fchany 0)))
  (setvar 'clayer "HIDDEN")
  (som (add-polyline blockObj
                     (list front_chan_web
                           fchany
                           0)
                     (list '(0 0 0)
                           (list 0 front_chan_len 0))
                     nil))
  (setvar 'textstyle "Calibri")
  (setvar 'clayer "TEXT")
  (setq obj (vla-AddText blockObj
                         front_chan
                         (vlax-3d-point 0 0 0)
                         4.0))
  (vla-put-Rotation obj (dtr 90.0))
  (vla-put-Alignment obj acAlignmentMiddleCenter)
  (setq frtexty (- (/ plt_wid 4.0)))
  (vla-put-TextAlignmentPoint obj
                              (vlax-3d-point (+ front_chan_wid 3)
                                             frtexty
                                             0))
  (if (= side "Left") (vla-mirror-y obj))
  (vla-put-ScaleFactor obj 0.8)
  ;;;;;;;;;;;;;;;
  ;; back channel
  ;;;;;;;;;;;;;;;
  (setvar 'clayer "OBJ")
  (setq bchany (- 0
                  (/ plt_wid 2.0)
                  br_ext
                  (if (and right_chan
                           (>= fr_ext br_ext))
                      (- right_chan_wid)
                    0)))
  (setq obj (add-rectangle blockObj
                           back_chan_wid
                           back_chan_len
                           (list back_chan_loc bchany 0)))
  ;; "mirror" if flipped
  (if (= flip_back "1") (progn
                          (vla-Move obj
                                    (vlax-3d-point 0 0 0)
                                    (vlax-3d-point (- back_chan_wid) 0 0))))
  (mirror obj)
  (setvar 'clayer "HIDDEN")
  (setq obj (add-polyline blockObj
                          (list (+ back_chan_loc back_chan_web)
                                bchany
                                0)
                          (list '(0 0 0)
                                (list 0 back_chan_len 0))
                          nil))
  ;; mirror if flipped
  (if (= flip_back "1") (progn
                          (setq tmp (vla-Mirror obj
                                                (vlax-3d-point back_chan_loc 0 0)
                                                (vlax-3d-point back_chan_loc 1 0)))
                          (vla-Delete obj)
                          (setq obj tmp)))
  (mirror obj)
  (setvar 'clayer "TEXT")
  (setq obj (vla-AddText blockObj
                         back_chan
                         (vlax-3d-point 0 0 0)
                         4.0))
  (vla-put-Rotation obj (dtr 90.0))
  (vla-put-Alignment obj acAlignmentMiddleCenter)
  (vla-put-TextAlignmentPoint obj
                              (vlax-3d-point (- back_chan_loc 3)
                                             frtexty
                                             0))
  (if (= flip_back "1") (vla-Move obj
                                  (vlax-3d-point 0 0 0)
                                  (vlax-3d-point (- back_chan_wid) 0 0)))
  (if (= side "Left") (vla-mirror-y obj))
  (vla-put-ScaleFactor obj 0.8)
  ;;;;;;;;;;;;;;;;
  ;; right channel
  ;;;;;;;;;;;;;;;;
  (if right_chan (progn
    (setvar 'clayer "OBJ")
    (som (add-rectangle blockObj
                        right_chan_len
                        right_chan_wid
                        (list (if (< fchany bchany) front_chan_wid 0)
                              (- (max fchany bchany) right_chan_wid)
                              0)))
    (setvar 'clayer "HIDDEN")
    (som (add-polyline blockObj
                       (list (if (< fchany bchany) front_chan_wid 0)
                             (- (max fchany bchany) right_chan_web)
                             0)
                       (list '(0 0 0)
                             (list right_chan_len 0 0))
                       nil))
    (setvar 'clayer "TEXT")
    (setq obj (vla-AddText blockObj
                           right_chan
                           (vlax-3d-point 0 0 0)
                           4.0))
    (vla-put-Alignment obj acAlignmentMiddleCenter)
    (vla-put-TextAlignmentPoint obj
                                (vlax-3d-point (/ back_chan_loc 2.0)
                                               (+ (max fchany bchany) 3)
                                               0))
    (mirror obj)
    (vla-put-ScaleFactor obj 0.8)))
  ;;;;;;;;;;;;;;;
  ;; left channel
  ;;;;;;;;;;;;;;;
  (if left_chan (progn
    (setvar 'clayer "OBJ")
    (setq fchany (+ fchany front_chan_len)
          bchany (+ bchany back_chan_len))
    (som (add-rectangle blockObj
                        left_chan_len
                        left_chan_wid
                        (list (if (>f fchany bchany 0.01) front_chan_wid 0)
                              (min fchany bchany)
                              0)))
    (setvar 'clayer "HIDDEN")
    (som (add-polyline blockObj
                       (list (if (>f fchany bchany 0.01) front_chan_wid 0)
                             (+ (min fchany bchany) left_chan_web)
                             0)
                       (list '(0 0 0)
                             (list left_chan_len 0 0))
                       nil))
    (setvar 'clayer "TEXT")
    (setq obj (vla-AddText blockObj
                           left_chan
                           (vlax-3d-point 0 0 0)
                           4.0))
    (vla-put-Alignment obj acAlignmentMiddleCenter)
    (vla-put-TextAlignmentPoint obj
                                (vlax-3d-point (/ back_chan_loc 2.0)
                                               (- (min fchany bchany) 3)
                                               0))
    (mirror obj)
    (vla-put-ScaleFactor obj 0.8)))
  ;;;;;;;;;;;
  ;; platform
  ;;;;;;;;;;;
  ;; line between stairs
  (setvar 'clayer "SOLID")
  (foreach f/b '("front" "back")
    (if (= "2 Stairs" (eval (read (strcat f/b "_bolt_to"))))
      (apply '(lambda (t-off t-wid b-wid b-off / x-val)
                (setq x-val (if (= f/b "front") 0 (* dir plt_dpt)))
                (add-polyline blockobj
                              (list x-val 0)
                              (list
                               (list 0 (- (* plt_wid 0.5) (+ t-off t-wid)))
                               (list 0 (+ (* plt_wid -0.5) (+ b-wid b-off))))
                              nil))
             (mapcar '(lambda (str) (eval (read (strcat f/b str))))
                     (apply 'append
                            ;; swap which side is the "top" stair for this view based on
                            ;; which side we're on
                            ((if (= side "Right") identity reverse)
                             '(("_l-stair_offset" "_l-stair_wid")
                               ("_r-stair_wid" "_r-stair_offset"))))))))
  ;; outer platform edge
  (mapcar
   '(lambda (lst) (add-polyline blockObj (list 0 0 0) lst nil))
    (mapcar 'cdr
      (vl-remove-if
       '(lambda (lst) (null (caar lst)))
        (break-path)
      ) ;_ vl-remove-if
    ) ;_ cdr
  ) ;_ mapcar
  ;; assembly tag
  (setvar 'clayer "TEXT")
  (setq obj (vla-AddText blockObj assembly (vlax-3d-point 0 0 0) 5.5))
  (vla-put-Alignment obj acAlignmentMiddleCenter)
  (vla-put-TextAlignmentPoint obj (vlax-3d-point (/ back_chan_loc 2.0)
                                                 (/ plt_wid 4.0)))
  (if (= side "Left") (vla-mirror-y obj))
  (vla-put-ScaleFactor obj 0.8)
  ;; reset and insert block
  (setvar 'clayer clayer)
  (setvar 'textstyle textstyle)
  (setq blockObj (insert-block modelSpace ins blockObj))
  (assign-xdata blockObj "LandTop" (format-xdata data))
  (vla-put-Layer blockObj "LAND")
  (setvar 'cmdecho 0)
  (command "DRAWORDER" (entlast) "" "b")
  (setvar 'cmdecho 1))
