(add-to-list 'sub-dialogs "tread_opts")

(setq tread_opts-dist-keys '("chk_hold")
      tread_opts-toggle-keys '("quiet_tread")
      tread_opts-keys (append tread_opts-dist-keys
                              tread_opts-toggle-keys)
      tread-styles '("100 Pan-filled"
                     "200 Checker Plate"))

;; set tread style options
(defun tread_style-action (value / )
  (if (begins-with value "2")
      (progn
        (if (not (assoc "chk_hold" tread_opts-val))
            (add-to-list 'tread_opts-val '("chk_hold" 0.75)))
        (if (not (assoc "quiet_tread" tread_opts-val))
            (add-to-list 'tread_opts-val '("quiet_tread" "0")))
        (mode_tile "tread_opts" 0))
    (progn
      (setq tread_opts-val nil)
      (mode_tile "tread_opts" 1))))

;; Initialize tread_opts sub-dialog.
;; This function is assigned automatically as the action for
;; tread_opts button.
;; It takes a dummy arg because the auto-action includes the key
;; which triggered it, which this function does not need.
(defun tread_opts-sub-init (dummy / tread-style local-scope )
  (setq tread-style (dialog-popup-val "tread_style"))

  ;; define symbols for dialog-init
  (defun local-scope ( / tmp
                         tread-def
                         popup-keys
                         dist-keys
                         int-keys
                         plain-string-keys
                         toggle-keys
                         tile-actions
                         default-actions
                         dialog-ties
                         sub-dialogs
                         dialog-after-load
                         dialog-before-start
                         dialog-before-done
                         )
    (defun dialog-after-load ()
      ;; turn on only keys which pertain to this invocation of the dialog
      (foreach key all-keys
               (mode_tile key 0)))
    
    (if (begins-with tread-style "2")
        (setq dist-keys '("chk_hold")
              toggle-keys '("quiet_tread")))

    (if (setq tmp (dialog-init "land/tread_opts.dcl" "tread_opts" tread_opts-val))
        (setq tread_opts-val (vl-remove-if '(lambda (x) (= (cdr x) nil)) tmp))))

  (local-scope))
