(set-file-docstring "Utility functions for landings")

(defun land-calc-can-spacing (/ start end len oc n)
  (expect-with-data "land-calc-can-spacing")
  (setq start (+ 3.25 (if (= fl_chan_num "85") (- fl_ext) 0))
        end (- plt_wid 3.25 (if (= fr_chan_num "85") (- fr_ext) 0))
        len (- end start)
        oc (cond ((= finish "Galvanized") 15.0)
                 ((= quiet_tread "1") 13.0)
                 (T 12.0))
        n (ceil (/ len oc))
        oc (/ len n))
  (append (list start)
          ((lambda(i / ret) (repeat (1- n) (setq i (+ i oc)) (add-to-list 'ret i)))
           start)
          (list end)))

  (defun calc-qtread-spacing ( / i cen-abv cen-blw ret qt-lng)
    (expect-with-data "calc-qtread-spacing")
    (defun qt-lng ( / l1 l2 l3)
      (setq
        l1
        (-
          plt_dpt
          (if (= front_bolt_to "None") 1 (+ front_chan_wid 1))
          (if (= back_bolt_to "None") 1 (+ back_chan_wid 1))
        ) ;_ -
        l2
        (-
          back_chan_loc
          (if (= front_bolt_to "None") 1 (+ front_chan_wid 1))
          (if (= "0" flip_back) 1 (+ back_chan_wid 1))
        ) ;_ -
        l3
        (-
          plt_dpt
          back_chan_loc
          (if (= "0" flip_back) back_chan_wid 0)
          2
        ) ;_ -
      ) ;_ setq
      (mapcar 'fix (list l1 l2 l3))
    ) ;_ defun qt-lng
    (setq i 1 cen-blw (land-calc-can-spacing))
    (apply-by-twos
     '(lambda (x1 x2) (add-to-list 'cen-abv (/ (- x2 x1) 2.0)))
      cen-blw
    ) ;_ apply-by-twos
    (setq cen-abv (mapcar '+ cen-abv cen-blw))
    (add-to-list 'ret
      (cons
       'cen-abv
        (mapcar
         '(lambda (cen)
            (list
              (list "wid" 4.0)
              (list "lng" (car (qt-lng)))
              (list "cen" cen)
              (list
                "off"
                (if (= front_bolt_to "None") 1 (+ front_chan_wid 1))
              ) ;_ list
              (list "hgt" (- chk_thk))
            ) ;_ list
          ) ;_ lambda
          cen-abv
        ) ;_ mapcar
      ) ;_ cons
    ) ;_ add-to-list
    (add-to-list 'ret
      (cons
       'cen-blw-f
        (mapcar
         '(lambda (cen)
            (if
              (and
                (= cen (car cen-blw))
                (< fl_ext (?n left_chan_wid))
              ) ;_ and
              (setq cen (1+ cen))
            ) ;_ if
            (if
              (and
                (= cen (last cen-blw))
                (< fr_ext (?n right_chan_wid))
              ) ;_ and
              (setq cen (1- cen))
            ) ;_ if
            (list
              (list "wid" (if (member cen cen-blw) 4.0 2.0))
              (list "lng" (cadr (qt-lng)))
              (list "cen" cen)
              (list
                "off"
                (if (= front_bolt_to "None") 1 (+ front_chan_wid 1))
              ) ;_ list
              (list "hgt" (- flr_thick))
            ) ;_ list
          ) ;_ lambda
          cen-blw
        ) ;_ mapcar
      ) ;_ cons
    ) ;_ add-to-list
    (if (>= (caddr (qt-lng)) 6)
      (add-to-list 'ret
        (cons
         'cen-blw-b
          (mapcar
           '(lambda (cen)
              (list
                (list "wid" 4.0)
                (list "lng" (caddr (qt-lng)))
                (list "cen" cen)
                (list
                  "off"
                  (+
                    back_chan_loc
                    (?n (if (= "0" flip_back) back_chan_wid))
                    1
                  ) ;_ +
                ) ;_ list
                (list "hgt" (- flr_thick))
              ) ;_ list
            ) ;_ lambda
            cen-blw
          ) ;_ mapcar
        ) ;_ cons
      ) ;_ add-to-list
    ) ;_ if
    ret
  ) ;_ defun calc-qtread-spacing

  (defun break-path ( / l-out l-max r-out r-max b-lst ret-lst)
    (setq
      l-out (member "85" (list fl_chan_num bl_chan_num))
      l-out (if l-out (abs (min fl_ext bl_ext)) 0.0)
      l-max (- (/ plt_wid 2.0) l-out)
      r-out (member "85" (list fr_chan_num br_chan_num))
      r-out (if r-out (abs (min fr_ext br_ext)) 0.0)
      r-max (- (- (/ plt_wid 2.0) r-out))
      b-lst (land-edge-form-locs)
    ) ;_ setq
    (setq ret-lst
      (mapcar
       '(lambda (f/b / l-off l-wid r-wid r-off)
          (setq
            l-off (eval (read (strcat f/b "_l-stair_offset")))
            l-wid (eval (read (strcat f/b "_l-stair_wid")))
            r-wid (eval (read (strcat f/b "_r-stair_wid")))
            r-off (eval (read (strcat f/b "_r-stair_offset")))
          ) ;_ setq
          (setq ret-lst
            (append
              (if (and (= f/b "front") (member 'front-left b-lst))
                (list
                  (append
                    (list '(T front-left))
                    (cond
                      ( (and (null l-off) (not (member 'right b-lst)))
                        (list (list 0.0 l-max) (list 0.0 (+ r-max (- r-wid r-out))))
                      ) ;_ condif
                      ( (null l-off)
                        (list (list 0.0 l-max) (list 0.0 (+ r-max (+ r-wid r-off))))
                      ) ;_ condif
                      ( (= T)
                        (list (list 0.0 l-max) (list 0.0 (- l-max l-off)))
                      ) ;_ condif
                    ) ;_ cond
                  ) ;_ append
                ) ;_ list
              ) ;_ if
              (if (and (= f/b "front") (member 'front b-lst))
                (list (list '(T front) (list 0.0 l-max) (list 0.0 r-max)))
              ) ;_ if
              (if (and (= f/b "front") (member 'front-right b-lst))
                (list
                  (append
                    (list '(T front-right))
                    (cond
                      ( (and (null r-off) (not (member 'right b-lst)))
                        (list (list 0.0 (- l-max (- l-wid l-out))) (list 0.0 r-max))
                      ) ;_ condif
                      ( (null r-off)
                        (list (list 0.0 (- l-max (+ l-wid l-off))) (list 0.0 r-max))
                      ) ;_ condif
                      ( (= T)
                        (list (list 0.0 (- r-max r-off)) (list 0.0 r-max))
                      ) ;_ condif
                    ) ;_ cond
                  ) ;_ append
                ) ;_ list
              ) ;_ if
              (if (= f/b "front")
                (list
                  (append
                    (list (list (if (member 'right b-lst) T) 'right))
                    (cond
                      ( (member 'right b-lst)
                        (list (list 0.0 r-max) (list plt_dpt r-max))
                      ) ;_ condif
                      ( (and
                          (or (member 'front-right b-lst) (member 'front b-lst))
                          (or (member 'back-right b-lst) (member 'back b-lst))
                        ) ;_ and
                        (list (list 0.75 r-max) (list (- plt_dpt 0.75) r-max))
                      ) ;_ condif
                      ( (or (member 'front-right b-lst) (member 'front b-lst))
                        (list (list 0.75 r-max) (list plt_dpt r-max))
                      ) ;_ condif
                      ( (or (member 'back-right b-lst) (member 'back b-lst))
                        (list (list 0.0 r-max) (list (- plt_dpt 0.75) r-max))
                      ) ;_ condif
                      ( (= T)
                        (list (list 0.0 r-max) (list plt_dpt r-max))
                      ) ;_ condif
                    ) ;_ cond
                  ) ;_ append
                ) ;_ list
              ) ;_ if
              (if (and (= f/b "back") (member 'back-right b-lst))
                (list
                  (append
                    (list '(T back-right))
                    (cond
                      ( (and (null r-off) (not (member 'right b-lst)))
                        (list (list plt_dpt r-max) (list plt_dpt (- l-max (- l-wid l-out))))
                      ) ;_ condif
                      ( (null r-off)
                        (list (list plt_dpt r-max) (list plt_dpt (- l-max (+ l-wid l-off))))
                      ) ;_ condif
                      ( (= T)
                        (list (list plt_dpt r-max) (list plt_dpt (- r-max r-off)))
                      ) ;_ condif
                    ) ;_ cond
                  ) ;_ append
                ) ;_ list
              ) ;_ if
              (if (and (= f/b "back") (member 'back b-lst))
                (list (list '(T back) (list plt_dpt r-max) (list plt_dpt l-max)))
              ) ;_ if
              (if (and (= f/b "back") (member 'back-left b-lst))
                (list
                  (append
                    (list '(T back-left))
                    (cond
                      ( (and (null l-off) (not (member 'right b-lst)))
                        (list (list plt_dpt (+ r-max (- r-wid r-out))) (list plt_dpt l-max))
                      ) ;_ condif
                      ( (null l-off)
                        (list (list plt_dpt (+ r-max (+ r-wid r-off))) (list plt_dpt l-max))
                      ) ;_ condif
                      ( (= T)
                        (list (list plt_dpt (- l-max l-off)) (list plt_dpt l-max))
                      ) ;_ condif
                    ) ;_ cond
                  ) ;_ append
                ) ;_ list
              ) ;_ if
              (if (= f/b "back")
                (list
                  (append
                    (list (list (if (member 'left b-lst) T) 'left))
                    (cond
                      ( (member 'left b-lst)
                        (list (list plt_dpt l-max) (list 0.0 l-max))
                      ) ;_ condif
                      ( (and
                          (or (member 'front-left b-lst) (member 'front b-lst))
                          (or (member 'back-left b-lst) (member 'back b-lst))
                        ) ;_ and
                        (list (list (- plt_dpt 0.75) l-max) (list 0.75 l-max))
                      ) ;_ condif
                      ( (or (member 'front-left b-lst) (member 'front b-lst))
                        (list (list plt_dpt l-max) (list 0.75 l-max))
                      ) ;_ condif
                      ( (or (member 'back-left b-lst) (member 'back b-lst))
                        (list (list (- plt_dpt 0.75) l-max) (list 0.0 l-max))
                      ) ;_ condif
                      ( (= T)
                        (list (list plt_dpt l-max) (list 0.0 l-max))
                      ) ;_ condif
                    ) ;_ cond
                  ) ;_ append
                ) ;_ list
              ) ;_ if
            ) ;_ append
          ) ;_ setq
        ) ;_ lambda
       '("front" "back")
      ) ;_ mapcar
    ) ;_ setq
    (setq ret-lst (apply 'append ret-lst))
    (mapcar!
     '(lambda (def)
        (cons
          (car def)
          (mapcar '(lambda (x) (mapcar '* (list dir dir) x)) (cdr def))
        ) ;_ cons
      ) ;_ lambda 
     'ret-lst
    ) ;_ mapcar!
  ) ;_ defun break-path

(defun land-qt-takeoff (/ qt-csv)
  (expect-with-data "land-qt-takeoff")
  (setq qt-csv (strcat (find-job-dir) "/qt.csv"))
  (vl-sort (count-items
            (mapcar '(lambda (qt)
                       (process-generic-def (list (xd-value "wid" qt) (xd-value "lng" qt)) qt-csv))
                    (map-append 'cdr (calc-qtread-spacing))))
           (sort-by 'caar '<)))

;; figure out which locations have an edge form
(defun land-edge-form-locs (/ locs)
  ;; front
  (if (= front_bolt_to "None")
      (add-to-list 'locs 'front)
    (progn
      ;; front left
      (if (or (and (= front_bolt_to "Right Stair") (<= (1+ front_r-stair_wid) plt_wid))
              (and front_l-stair_offset (>= front_l-stair_offset 1)))
          (add-to-list 'locs 'front-left))
      ;; front right
      (if (or (and (= front_bolt_to "Left Stair") (<= (1+ front_l-stair_wid) plt_wid))
              (and front_r-stair_offset (>= front_r-stair_offset 1)))
          (add-to-list 'locs 'front-right))))
  ;; back
  (if (= back_bolt_to "None")
      (add-to-list 'locs 'back)
    (progn
      ;; back left
      (if (or (and (= back_bolt_to "Right Stair") (<= (1+ back_r-stair_wid) plt_wid))
              (and back_l-stair_offset (>= back_l-stair_offset 1)))
          (add-to-list 'locs 'back-left))
      ;; back right
      (if (or (and (= back_bolt_to "Left Stair") (<= (1+ back_l-stair_wid) plt_wid))
              (and back_r-stair_offset (>= back_r-stair_offset 1)))
          (add-to-list 'locs 'back-right))))
  ;; left
  (if (not (member "85" (list fl_chan_num bl_chan_num)))
      (add-to-list 'locs 'left))
  ;; right
  (if (not (member "85" (list fr_chan_num br_chan_num)))
      (add-to-list 'locs 'right))
  locs)

  (defun-q face-defs (obj / face-norm dat def app)
    "Generates x-brace definition for use with %face-draw"
    (defun face-norm (ins nor qty wid hgt)
      (list
        (list (if (= (car nor) 0) (car ins) 0) (caddr ins))
        (list 0 0 1) qty wid hgt
      ) ;_ list
    ) ;_ defun face-norm
    (setq
      dat (get-xdata-find obj "Land")
      def (with-data dat '((x-brace-defs)))
      app (xd-value "app_id" (read-xdata obj ""))
    ) ;_ setq
    (remove! 'def '(equal (if (= "Land" app) '(1 0 0) '(0 1 0)) (cadr x)))
    (setq def (map-apply 'face-norm def))
  ) ;_ defun-q face-defs
  (defun-r 'face-defs)

  (defun-q face-draw (obj def / blockobj conn supp)
    "Insert x-brace geometry based on def into obj"
    (setq blockobj (blockref2def obj))
    (draw-xbrace blockobj nil lay def)
    (cond
      ( (= "Land" app_id)
        (foreach corner
          (if (= "Left" side) '("fl" "bl") '("fr" "br"))
          ( (lambda (def) (apply (car def) (cdr def)))
            (land-support-def corner 'sv)
          ) ;_ lambda-func
        ) ;_ foreach
      ) ;_ condif
      ( (= T) (list))
    ) ;_ cond
  ) ;_ defun-q face-draw
  (defun-r 'face-draw)
