
  ;;; keys not present in the dialog, but calcuated and added to the block
  (setq guard-derived-keys
   '( "version"
      "assembly"
      "cen-dst"
      "clr-dst"
      "num-mid"
      "num-pipe"
      "num-pipe"
      "num-tube"
      "num-pick"
      "pick-spc"
      "pick-lng"
    ) ;_ quoted-list
  ) ;_ setq

  ;;; add keys calculated from dialog keys
  (defun guard-add-derived-keys (data / inner this-func calc-n-200 calc-n-300 calc-n-400)
    (defun-q inner ( / add ret wid)
      ;; make all derived keys local to this function
      (defun add (key val)
        (set (read key) val)
        (add-to-list 'ret (list key val))
      ) ;_ defun add
      (setq wid (if (zerop (read guard_sty)) 0.0 1.5))
      (add "version" guard-version)
      (add "assembly"
        (strcat "GR" number "-" level (to-string sequence))
      ) ;_ add
      (add "num-mid" (rail-calc-n-mid-posts (- guard_lng wid)))
      (add "cen-dst"
        (/ (- guard_lng wid) (1+ (xd-value "num-mid" ret)))
      ) ;_ add
      (if (not (zerop (read guard_sty)))
        (add "clr-dst" (- (xd-value "cen-dst" ret) wid))
      ) ;_ if
      (cond
        ( (= 100 (read guard_sty)) (add "num-pipe" 1))
        ( (= 200 (read guard_sty)) (add "num-pipe" (calc-n-200)))
        ( (= 300 (read guard_sty)) (add "num-tube" (calc-n-300)))
        ( (= 400 (read guard_sty)) (add "num-pick" (calc-n-400)))
        ( (= T) nil)
      ) ;_ cond
      (append! 'data (vl-sort ret sort-data-by-key))
    ) ;_ defun-q inner
    (defun calc-n-200 ( / i y)
      (setq i 0 y (- guard_hgt 14.33))
      (while (>= y 4.705) (inc! 'i) (setq y (- y 5.535)))
      (if (and (not location) (= guard_hand "0")) (inc! 'i))
      (if (all-X12) 5 i)
    ) ;_ defun calc-n-200
    (defun calc-n-300 ( / i y)
      (setq i 0 y (- guard_hgt 1.5))
      (while (>= y 5.375) (inc! 'i) (setq y (- y 5.25)))
      (* i (1+ (xd-value "num-mid" ret)))
    ) ;_ defun calc-n-300
    (defun calc-n-400 ( / i x clr spc off box)
      (setq
        clr (xd-value "clr-dst" ret)
        spc (rail-calc-picket-spacing clr)
        off (+ spc 0.5) x off i 0
        box (vl-every
             '(lambda (x) (member (guard-con-read x) '(12)))
              (list lpost_con mpost_con rpost_con)
            ) ;_ vl-every
      ) ;_ setq
      (add "pick-spc" spc)
      (add "pick-lng" (- guard_hgt (if box 3.0 8.5) 0.125))
      (while (< x clr) (inc! 'i) (setq x (+ x off)))
      (* i (1+ (xd-value "num-mid" ret)))
    ) ;_ defun calc-n-400
    (setq this-func (defun-q-list-ref 'inner))
    (defun-q-list-set 'inner
      (cons
        (append (car this-func) (mapcar 'read guard-derived-keys))
        (cdr this-func)
      ) ;_ cons
    ) ;_ defun-q-list-set
    (with-data data '((inner)))
  ) ;_ defun guard-add-derived-keys
