
  (psc-include (list "common-data.lsp" "dialog/dialog.lsp" "rail/util.lsp"))

  (defun guard-dialog (dat / tog-lst dtl-lst sty-lst plain-string-keys int-keys dist-keys toggle-keys popup-keys default-actions dialog-after-load dialog-after-save dialog-before-done tile-actions extra-keys dialog-ties sub-dialogs)
    (map-apply! '(lambda (key val) (list key (to-string val))) 'dat)
    (set-dialog-vars)
    (defun dialog-after-load ()
      (guard-sty-format "guard_sty" (xd-value "guard_sty" dat))
    ) ;_ defun dialog-after-load
    (defun dialog-before-done ( / sty)
      (auto-set-post-ext)
      (setq sty (guard-sty-read (dialog-popup-val "guard_sty")))
      (subst-key! "guard_sty" sty 'data)
    ) ;_ defun dialog-before-done
    (dialog-init "rail/guard.dcl" "DD_GUARD" dat)
  ) ;_ defun guard-dialog

  (defun multi-guard-dialog ( / multi-p tog-lst dtl-lst sty-lst plain-string-keys int-keys dist-keys toggle-keys popup-keys default-actions dialog-after-load dialog-after-save dialog-before-done tile-actions extra-keys dialog-ties sub-dialogs)
    (map-apply! '(lambda (key val) (list key (to-string val))) 'dat)
    (set-dialog-vars)
    (setq multi-p T)
    (defun dialog-after-load ( / )
      (mapcar
       '(lambda (k) (mode_tile k 1))
        (apply 'append (mapcar 'cdr tog-lst))
      ) ;_ mapcar
      (guard-sty-format "guard_sty" (dialog-popup-val "guard_sty"))
    ) ;_ defun dialog-after-load
    (defun dialog-before-done ( / sty exclude-lst)
      (setq
        exclude-lst tog-lst
        exclude-lst (remove exclude-lst '(= "1" (get_tile (car x))))
        exclude-lst (apply 'append (mapcar 'cdr exclude-lst))
        exclude-lst (remove exclude-lst '(ends-with x "_txt"))
        sty (guard-sty-read (dialog-popup-val "guard_sty"))
      ) ;_ setq
      (subst-key! "guard_sty" sty 'data)
      (remove! 'data '(begins-with (car x) "tog_"))
      (remove! 'data '(member (car x) exclude-lst))
      (auto-set-post-ext)
    ) ;_ defun dialog-before-done
    (dialog-init "rail/guard.dcl" "MULTI_DD_GUARD" nil)
  ) ;_ defun multi-guard-dialog

  (defun post-handling (key val / mode tmp tab txt ext def mid-p rgt-p mlt-p)
    (defun mid-p ( / btwn dist)
      (setq btwn (member (guard-con-read val) '(11 12)))
      (setq dist (distof (get_tile "guard_lng")))
      (setq mode (if (or (<= dist 49.5) btwn) 1 0))
      (mode_tile "mid_post" mode)
    ) ;_ defun mid-p
    (defun rgt-p ()
      (setq mode (if (member (guard-con-read val) '(11 12)) 1 0))
      (mode_tile "right_post" mode)
    ) ;_ defun rgt-p
    (defun mlt-p (key / tog)
      (setq tog (caar (filter tog-lst '(member key x))))
      (setq tog (abs (1- (atoi (get_tile tog)))))
      tog
    ) ;_ defun mlt-p
    (cond
      ( (= multi-p T) (mlt-p key))
      ( (= key "mpost_con") (mid-p))
      ( (= key "rpost_con") (rgt-p))
      ( (= T) (setq mode 0))
    ) ;_ cond
    (setq
      tmp (substr key 1 6)
      tab (strcat tmp "tab")
      txt (strcat tmp "txt")
      ext (strcat tmp "ext")
      def (guard-dcl-defaults)
    ) ;_ setq
    (map-apply! '(lambda (key val) (list key (to-string val))) 'def)
    (cond ;;; Kick & Hrail @ Guard Btwn. & Cane Rail
      ( (member (guard-con-read val) '(11 12 30 31))
        (foreach k '("hand_txt" "kick_txt") (mode_tile k 1))
        (foreach k '("guard_hand" "guard_kick")
          (mode_tile k 1) (set_tile k "0")
        ) ;_ foreach
        (hr-ret-handling "guard_hand" (get_tile "guard_hand"))
      ) ;_ condif
      ( (= T)
        (foreach k '("hand_txt" "kick_txt" "guard_hand" "guard_kick")
          (mode_tile k (if multi-p (mlt-p k) 0))
        ) ;_ foreach
        (foreach k '("guard_hand" "guard_kick")
          (if (or (not multi-p) (= 0 (mlt-p k)))
            (set_tile k (xd-value k (if dat dat def)))
          ) ;_ if
        ) ;_ foreach
      ) ;_ condif
    ) ;_ cond
    (cond ;;; Knife Plate
      ( (member (guard-con-read val) '(7 47 51))
        (mode_tile tab (if multi-p (mlt-p tab) mode))
        (set_tile tab (xd-value tab (if dat dat def)))
      ) ;_ condif
      ( (= T)
        (mode_tile tab 1)
        (set_tile tab "0.0")
      ) ;_ condif
    ) ;_ cond
    (cond ;;; Post Extension
      ( (member (guard-con-read val) '(11 12 30 31 41 42 43 44))
        (mode_tile txt 1) (mode_tile ext 1)
        (set_tile txt "Extension") (set_tile ext "0.0")
      ) ;_ condif
      ( (= T)
        (foreach k (list txt ext)
          (mode_tile k (if multi-p (mlt-p k) mode))
        ) ;_ foreach
        (set_tile txt (if (= (guard-con-read val) 8) "Nose Dist." "Extension"))
        (set_tile ext (to-string (abs (distof (xd-value ext (if dat dat def))))))
      ) ;_ condif
    ) ;_ cond
  ) ;_ defun post-handling

  (defun post-auto-format (key val)
    (post-handling key val)
    (foreach con '("mpost_con" "rpost_con")
      (set_tile con (itoa (dialog-popup-idx key val)))
      (post-handling con val)
    ) ;_ foreach
  ) ;_ defun post-auto-format

  (defun post-auto-fill (key val / tmp)
    (setq tmp (substr key 6 4))
    (if
      (apply '=
        (mapcar 'get_tile '("lpost_con" "mpost_con" "rpost_con"))
      ) ;_ apply
      (progn
        (set_tile (strcat "mpost" tmp) (to-string val))
        (set_tile (strcat "rpost" tmp) (to-string val))
      ) ;_ progn
    ) ;_ if
  ) ;_ defun post-auto-fill

  (defun guard-inc-mpost (key val)
    (post-handling "mpost_con" (dialog-popup-val "mpost_con"))
  ) ;_ defun guard-inc-mpost

  (defun guard-sty-format (key val / crail-p con-lst def tmp)
    (setq
      crail-p (= (read val) 010)
      con-lst (list "030 WAGNER ANCH." "031 EMBED TOP")
      con-lst (if crail-p con-lst dtl-lst)
      def (guard-dcl-defaults)
    ) ;_ setq
    (foreach con '("lpost_con" "mpost_con" "rpost_con")
      (dialog-popup-list-set con con-lst)
      (setq
        tmp (xd-value con (?? dat def))
        tmp (dialog-popup-idx con tmp)
      ) ;_ setq
      (set_tile con (if tmp (itoa tmp) "0"))
      (post-handling con (dialog-popup-val con))
    ) ;_ foreach
    (hr-ret-handling "guard_hand" (get_tile "guard_hand"))
  ) ;_ defun guard-sty-format

  (defun guard-sty-read (str)
    (setq str
      (strcat
        (substr str 1 1)
        (itoa (abs (1- (read (substr str 2 1)))))
        (substr str 3 (strlen str))
      ) ;_ strcat
    ) ;_ setq
  ) ;_ defun guard-sty-read

  (defun guard-dcl-defaults ()
    (vl-propagate 'guard-dat-val)
    (if (null guard-dat-val)
      (setq guard-dat-val
        (list
         '("number" "1")
         '("level" "1")
         '("sequence" "A")

         '("guard_lng" "36.0")
         '("guard_hgt" "42.75")
         '("guard_qty" "1")

         '("guard_sty" "210 6-Line")
         '("guard_hand" "0")
         '("guard_kick" "1")
         '("finish" "Rodda Barrier III Red Oxide")
         '("comment" "")

         '("lpost_con" "041 KB-TZ ANCH.")
         '("lpost_ext" "0.0")
         '("lpost_tab" "0.0")

         '("mpost_con" "041 KB-TZ ANCH.")
         '("mpost_ext" "0.0")
         '("mpost_tab" "0.0")

         '("rpost_con" "041 KB-TZ ANCH.")
         '("rpost_ext" "0.0")
         '("rpost_tab" "0.0")

         '("hrl_con" "X17 None")
         '("hrl_off" "0.3125")
         '("hrl_gap" "")
         '("hrl_ang" "")

         '("hrr_con" "X17 None")
         '("hrr_off" "0.3125")
         '("hrr_gap" "")
         '("hrr_ang" "")
        ) ;_ list
      ) ;_ setq
    ) ;_ if
    guard-dat-val
  ) ;_ defun guard-dcl-defaults

  (defun set-dialog-vars ( / sty con-lst)
    (defun con-lst (lst)
      (mapcar 'cons (cdr lst) (lst* (car lst) (length (cdr lst))))
    ) ;_ defun con-lst
    (setq sty (guard-sty-read (xd-value "guard_sty" dat)))
    (subst-key! "guard_sty" sty 'dat)
    (setq
      ret-lst
        (list "X13 Bend Up" "X14 Bend Dn" "X15 To Post" "X16 Cap End" "X17 None")
      sty-lst
        (list "010 Cane" "110 2-Line" "210 6-Line" "310 Tube" "410 Picket")
      dtl-lst
        (list
          "041 KB-TZ ANCH."       "042 KH-EZ ANCH."
          "043 EMBED TOP"         "044 EMBED TOP"
          "045 EMBED SIDE"        "046 BLK. OUT SIDE"
          "047 W.F. BEAM"         "048 DECKING"
          "050 LAND. CH. FLUSH"   "051 LAND. CH. PLATE"
          "052 LAND. CH. TOP"     "06X PL. STR. SIDE"
          "07X CH. STR. SIDE"     "08X CH. STR. TOP"
          "X11 BTWN. NARROW"      "X12 BTWN. WIDE"
        ) ;_ list
      tog-lst
        (list
         '("tog_str" "number")  '("tog_lvl" "level")  '("tog_seq" "sequence") '("tog_fin" "finish")
         '("tog_lng" "guard_lng")  '("tog_hgt" "guard_hgt")  '("tog_qty" "guard_qty") '("tog_com" "comment")
         '("tog_hrlc"  "hrl_con")  '("tog_hrlg"  "hrl_gap")  '("tog_hrlo"  "hrl_off")  '("tog_hrla"  "hrl_ang")
         '("tog_hrrc"  "hrr_con")  '("tog_hrrg"  "hrr_gap")  '("tog_hrro"  "hrr_off")  '("tog_hrra"  "hrr_ang")
         '("tog_sty" "guard_sty")  '("tog_hnd" "hand_txt" "guard_hand")  '("tog_kck" "kick_txt" "guard_kick")
         '("tog_lcon" "lpost_con") '("tog_ltab" "lpost_tab") '("tog_lext" "lpost_txt" "lpost_ext")
         '("tog_mcon" "mpost_con") '("tog_mtab" "mpost_tab") '("tog_mext" "mpost_txt" "mpost_ext")
         '("tog_rcon" "rpost_con") '("tog_rtab" "rpost_tab") '("tog_rext" "rpost_txt" "rpost_ext")
        ) ;_ list
      ;;; edit boxes (get_tile)
      plain-string-keys (list "number" "level" "sequence" "comment")
      ;;; edit boxes (safe-atoi)
      int-keys (list "guard_qty")
      ;;; edit boxes (distof)
      dist-keys
        (list
          "guard_lng" "guard_hgt"
          "lpost_ext" "mpost_ext" "rpost_ext"
          "lpost_tab" "mpost_tab" "rpost_tab"
          "hrl_gap"   "hrl_off"   "hrl_ang"
          "hrr_gap"   "hrr_off"   "hrr_ang"
        ) ;_ list
      ;;; toggle tiles
      toggle-keys
        (list
          "guard_hand"  "guard_kick"
          "tog_fin"     "tog_com"
          "tog_str"     "tog_lng"     "tog_sty"
          "tog_lvl"     "tog_hgt"     "tog_hnd"
          "tog_seq"     "tog_qty"     "tog_kck"
          "tog_lcon"    "tog_mcon"    "tog_rcon"
          "tog_lext"    "tog_mext"    "tog_rext"
          "tog_ltab"    "tog_mtab"    "tog_rtab"
          "tog_hrlc"    "tog_hrlg"    "tog_hrlo"    "tog_hrla"
          "tog_hrrc"    "tog_hrrg"    "tog_hrro"    "tog_hrra"
        ) ;_ list
      ;;; key list for popup list tiles
      popup-keys
        (list
          (cons "guard_sty" sty-lst)
          (cons "finish" finishes)
          (cons "lpost_con" dtl-lst)
          (cons "mpost_con" dtl-lst)
          (cons "rpost_con" dtl-lst)
          (cons "hrl_con" ret-lst)
          (cons "hrr_con" ret-lst)
        ) ;_ list
      default-actions
        (append
         '(("guard_lng" . guard-inc-mpost))
         '(("guard_sty" . guard-sty-format))
         '(("lpost_con" . post-auto-format))
         '(("guard_hand" . hr-ret-handling))
          (con-lst '(hr-ret-formatting "hrl_con" "hrr_con"))
          (con-lst '(post-auto-fill "lpost_ext" "lpost_tab"))
          (con-lst '(post-handling "mpost_con" "rpost_con"))
          (con-lst '(force-uppercase "number" "level" "sequence"))
          (con-lst  (cons 'multi-tog-handling (cddr toggle-keys)))
        ) ;_ append
    ) ;_ setq
  ) ;_ defun set-dialog-vars

  (defun multi-tog-handling (key val / def lst)
    (setq def (guard-dcl-defaults) lst tog-lst)
    (filter! 'lst '(= key (car x)))
    (mapcar
     '(lambda (k / d)
        (setq d (xd-value k (if dat dat def)))
        (mode_tile k (abs (1- (atoi val))))
        (if d (set_tile k (to-string d)))
      ) ;_ lambda
      (cdr (apply 'append lst))
    ) ;_ mapcar
  ) ;_ defun tog-handling

  (defun auto-set-post-ext ()
    (mapcar
     '(lambda (con key)
        (if (= con 8) (subst-key! key (- (xd-value key data)) 'data))
      ) ;_ lambda
      (with-data data
       '( (mapcar
            (compose '(guard-con-read to-string))
            (list lpost_con mpost_con rpost_con)
          ) ;_ mapcar
        ) ;_ quoted-list
      ) ;_ with-data
      (list "lpost_ext" "mpost_ext" "rpost_ext")
    ) ;_ mapcar
  ) ;_ defun auto-set-post-ext

  (defun hr-ret-handling (key val)
    (setq val (abs (1- (atoi val))))
    (mapcar '(lambda (k) (mode_tile k val)) '("Lret" "Rret"))
    (foreach con '("hrl_con" "hrr_con")
      (if (or (= (get_tile "guard_hand") "0") (null (xd-value con dat)))
        (progn (set_tile con "4") (hr-ret-formatting con "X17"))
        (progn
          (set_tile con (itoa (dialog-popup-idx con (xd-value con dat))))
          (foreach key
           '("hrl_off" "hrl_ang" "hrl_gap" "hrr_off" "hrr_ang" "hrr_gap")
            (setq val (to-string (xd-value key dat)))
            (if (= val "") (mode_tile key 1) (set_tile key val))
          ) ;_ foreach
        ) ;_ progn
      ) ;_ if
    ) ;_ foreach
  ) ;_ defun hr-ret-handling

  (defun hr-ret-formatting (key val / l/r off ang gap calc-gap fill-val)
    (defun calc-gap ()
      (if (= 210 (read (dialog-popup-val "guard_sty"))) "3.625" "2.125")
    ) ;_ defun calc-gap
    (defun fill-val (key def / str)
      (setq str (to-string (xd-value key dat)))
      (if (= str "") def str)
    ) ;_ defun fill-val
    (setq
      val (read val) l/r (substr key 1 4)
      off (strcat l/r "off") ang (strcat l/r "ang") gap (strcat l/r "gap")
    ) ;_ setq
    (mapcar
     '(lambda (k) (mode_tile k (if (member val '(X13 X14)) 0 1)))
      (list ang gap)
    ) ;_ mapcar
    (map-apply
     '(lambda (key val) (set_tile key val))
      (cond
        ( (= 010 (read (dialog-popup-val "guard_sty")))
          (list (list off "") (list ang "") (list gap ""))
        ) ;_ condif
        ( (member val '(X13 X14))
          (list
            (list off (if (= val 'X13) "-11.0" "0.0"))
            (list ang (fill-val ang "32.47"))
            (list gap (fill-val gap (calc-gap)))
          ) ;_ list
        ) ;_ condif
        ( (= val 'X15)
          (list (list off "-0.75") (list ang "90") (list gap ""))
        ) ;_ condif
        ( (member val '(X16 X17))
          (list (list off "-0.3125") (list ang "") (list gap ""))
        ) ;_ condif
        ( (= T)
          (list (list off "") (list ang "") (list gap ""))
        ) ;_ condif
      ) ;_ cond
    ) ;_ map-apply
  ) ;_ defun hr-ret-formatting
