  ;;; Functions to update the guard XDATA specification over time

  (setq guard-version 4)

  ;;; derived-key only migrations: 4

  ;;; add handrail options
  (defun guard-migration-1 (data / )
    (foreach hr '("hrl_" "hrr_")
      (add-to-list 'data (list (strcat hr "con") "X17 None"))
      (add-to-list 'data (list (strcat hr "off") 0.0))
      (add-to-list 'data (list (strcat hr "ang") 0.0))
    ) ;_ foreach
    data
  ) ;_ defun guard-migration-1

  ;;; add gaps, finish, and comment
  (defun guard-migration-2 (data / gap)
    (setq gap
      (if (= 200 (read (xd-value "guard_sty" data))) 3.625 2.125)
    ) ;_ setq
    (foreach hr '("hrl_" "hrr_")
      (add-to-list 'data (list (strcat hr "gap") gap))
    ) ;_ foreach
    (add-to-list 'data (list "guard_fin" "Rodda Barrier III Red Oxide"))
    (add-to-list 'data (list "guard_com" ""))
    data
  ) ;_ defun guard-migration-2

  ;;; change xdata keys to streamline fab dwg processes
  (defun guard-migration-3 (data)
    (map-apply
     '(lambda (old new)
        (subst! (list new (xd-value old data)) (assoc old data) 'data)
      ) ;_ lambda
     '( ("guard_str" "number") ("guard_lvl" "level")
        ("guard_seq" "sequence") ("guard_fin" "finish")
        ("guard_ass" "assembly") ("guard_com" "comment")
      ) ;_ list
    ) ;_ map-apply
    data
  ) ;_ guard-migration-3
