  (set-file-docstring "Functions for creating a rail section")

  (defun-q rail-section-a-flight ( / s-lst r-lst h-lst t-lst d-lst)
    "create rail section for a-flight"
    (progn ; a-flt stair
      (add-to-list 's-lst
        (add-shape ; inside stringer
          lbk
          (list (- a-flt_i-string_wid) a-flt_i-nosing_top)
          a-flt_i-string_mat
        ) ;_ add-shape
      ) ;_ add-to-list
      (add-to-list 's-lst
        (mirror&delete
          (add-shape ; outside stringer
            lbk
            (list
              (- (+ a-flt_btwn_stringers a-flt_i-string_wid))
              a-flt_o-nosing_top
            ) ;_ list
            a-flt_o-string_mat
          ) ;_ add-shape
          (list
            (- (+ a-flt_btwn_stringers a-flt_i-string_wid))
            a-flt_o-nosing_top
          ) ;_ list
          'Y
        ) ;_ mirror&delete
      ) ;_ add-to-list
      (add-to-list 'h-lst
        (add-polyline ; lower nosing
          lbk
          (list (- a-flt_i-string_wid) 0)
          (list '(0 0) (list (- a-flt_btwn_stringers) 0))
          nil
        ) ;_ add-polyline
      ) ;_ add-to-list
    ) ;_ progn

    (cond ; a-flt inside rail
      ( (wcmatch a-flt_i-rail_type "*Wall*")
        (add-to-list 's-lst
          (add-polyline
            lbk
            (list 0 0)
            (mapcar
             '(lambda (y) (list a-gap y))
              (list -18 (+ (* 4 b-flt_rise_hgt) 84.75))
            ) ;_ mapcar
            nil
          ) ;_ add-polyline
        ) ;_ add-to-list
        (hr&bracket lbk (list (- a-gap 2.33) 34) 1 "W" "I")
        (add-to-list 't-lst
          (vlax-put-property-r
            (add-text ; a-flt fof
              lbk
              (list (- a-gap 3.0) (+ (* 4 b-flt_rise_hgt) 78.75))
              "FOF"
              3.0
              1.0
              'MiddleCenter
            ) ;_ add-text
            "Rotation"
            (dtr 90)
          ) ;_ vlax-put-property-r
        ) ;_ add-to-list
      ) ;_ condif
      ( (wcmatch a-flt_i-rail_type "*Stair*")
        (hr&bracket lbk (list (if (= "0" a-flt_i-rail_topmnt) -2.33 -3.83) 34) 1 "S" "I")
        (add-to-list 's-lst
          (add-rectangle
            lbk
            ((if (= "0" a-flt_i-rail_topmnt) + -) 1.5)
            (if (= "0" a-flt_i-rail_topmnt) -50 (- a-flt_i-nosing_top 42.75))
            (list 0 42.75)
          ) ;_ add-rectangle
        ) ;_ add-to-list
      ) ;_ condif
      ( (= T) (princ))
    ) ;_ cond

    (cond ; a-flt outside rail
      ( (wcmatch a-flt_o-rail_type "*Wall*")
        (add-to-list 's-lst
          (add-polyline
            lbk
            (list 0 0)
            (mapcar
             '(lambda (y) (list (- (+ a-flt_width a-gap)) y))
              (list -18 (+ (* 4 b-flt_rise_hgt) 84.75))
            ) ;_ mapcar
            nil
          ) ;_ add-polyline
        ) ;_ add-to-list
        (hr&bracket lbk (list (- (+ a-flt_width a-gap -2.33)) 34) -1 "W" "O")
        (add-to-list 't-lst
          (vlax-put-property-r
            (add-text ; a-flt fof
              lbk
              (list
                (- (+ a-flt_width a-gap -3))
                (+ (* 4 b-flt_rise_hgt) 78.75)
              ) ;_ list
              "FOF"
              3.0
              1.0
              'MiddleCenter
            ) ;_ add-text
            "Rotation"
            (dtr 90)
          ) ;_ vlax-put-property-r
        ) ;_ add-to-list
      ) ;_ condif
      ( (wcmatch a-flt_o-rail_type "*Stair*")
        (hr&bracket
          lbk
          (list (- (+ a-flt_width (if (= "0" a-flt_o-rail_topmnt) -2.33 -3.83))) 34)
          -1
          "S"
          "O"
        ) ;_ hr&bracket
        (add-to-list 's-lst
          (add-rectangle
            lbk
            ((if (= "0" a-flt_o-rail_topmnt) - +) 1.5)
            (if (= "0" a-flt_o-rail_topmnt) -50 (- a-flt_o-nosing_top 42.75))
            (list (- a-flt_width) 42.75)
          ) ;_ add-rectangle
        ) ;_ add-to-list
      ) ;_ condif
      ( (= T) (princ))
    ) ;_ cond

    (format)

  ) ;_ defun-q rail-section-a-flight
  (defun-r 'rail-section-a-flight)

  (defun-q rail-section-b-flight ( / s-lst r-lst h-lst t-lst d-lst)
    "create rail section for b-flight"
    (progn ; b-flt stair
      (add-to-list 's-lst
        (add-shape ; inside stringer
          ubk
          (list (- b-flt_i-string_wid) (+ b-flt_rise_hgt b-flt_i-nosing_bot))
          b-flt_i-string_mat
        ) ;_ add-shape
      ) ;_ add-to-list
      (add-to-list 's-lst
        (mirror&delete ; outside stringer
          (add-shape
            ubk
            (list (- (+ b-flt_btwn_stringers b-flt_i-string_wid)) (+ b-flt_rise_hgt b-flt_o-nosing_bot))
            b-flt_o-string_mat
          ) ;_ add-shape
          (list (- (+ b-flt_btwn_stringers b-flt_i-string_wid)) (+ b-flt_rise_hgt b-flt_o-nosing_bot))
          'Y
        ) ;_ mirror&delete
      ) ;_ add-to-list
      (mapcar ; inside/outside stringer outline
       '(lambda (w x y)
          (add-to-list 's-lst
            (add-rectangle ubk w (* 3 b-flt_rise_hgt) (list x (+ b-flt_rise_hgt y)))
          ) ;_ add-to-list
        ) ;_ lambda
        (list (- b-flt_i-string_wid) b-flt_o-string_wid)
        (list 0 (- b-flt_width))
        (list b-flt_i-nosing_bot b-flt_o-nosing_bot)
      ) ;_ mapcar
      (mapcar ; upper nosings
       '(lambda (i)
          (add-to-list 'h-lst
            (add-polyline
              ubk
              (list (- b-flt_i-string_wid) 0)
              (list
                (list 0 (* i b-flt_rise_hgt))
                (list (- b-flt_btwn_stringers) (* i b-flt_rise_hgt))
              ) ;_ list
              nil
            ) ;_ add-polyline
          ) ;_ add-to-list
        ) ;_ lambda
       '(0 1 2 3 4)
      ) ;_ mapcar
    ) ;_ progn

    (cond ; b-flt inside rail
      ( (wcmatch b-flt_i-rail_type "*Wall*")
        (add-to-list 's-lst ; b-flt wall
          (add-polyline
            ubk
            (list 0 0)
            (mapcar
             '(lambda (y) (list b-gap y))
              (list -18 (+ (* 4 b-flt_rise_hgt) 84.75))
            ) ;_ mapcar
            nil
          ) ;_ add-polyline
        ) ;_ add-to-list
        (hr&bracket ubk (list (- b-gap 2.33) (+ b-flt_rise_hgt 34)) 1 "W" "I")
        (add-to-list 't-lst
          (vlax-put-property-r
            (add-text
              ubk
              (list (- b-gap 3.0) (+ (* 4 b-flt_rise_hgt) 78.75))
              "FOF"
              3.0
              1.0
              'MiddleCenter
            ) ;_ add-text
            "Rotation"
            (dtr 90)
          ) ;_ vlax-put-property-r
        ) ;_ add-to-list
      ) ;_ condif
      ( (wcmatch b-flt_i-rail_type "*Stair*")
        (hr&bracket
          ubk
          (list
            (if (= "0" b-flt_i-rail_topmnt) -2.33 -3.83)
            (+ b-flt_rise_hgt 34)
          ) ;_ list
          1
          "S"
          "I"
        ) ;_ hr&bracket
        (add-to-list 's-lst
          (add-rectangle
            ubk
            ((if (= "0" b-flt_i-rail_topmnt) + -) 1.5)
            (- (+ 42.75 (- (* 3 b-flt_rise_hgt) (* 2.0 b-flt_i-nosing_bot))))
            (list 0 (+ (* 4 b-flt_rise_hgt) 42.75))
          ) ;_ add-rectangle
        ) ;_ add-to-list
      ) ;_ condif
      ( (= T) (princ))
    ) ;_ cond

    (cond  ; b-flt outside rail
      ( (wcmatch b-flt_o-rail_type "*Wall*")
        (add-to-list 's-lst  ; b-flt wall
          (add-polyline
            ubk
            (list 0 0)
            (list
              (list (- (+ b-flt_width b-gap)) -18)
              (list (- (+ b-flt_width b-gap)) (+ (* 4 b-flt_rise_hgt) 84.75))
            ) ;_ list
            nil
          ) ;_ add-polyline
        ) ;_ add-to-list
        (hr&bracket
          ubk
          (list (- (+ b-flt_width b-gap -2.33)) (+ b-flt_rise_hgt 34))
          -1
          "W"
          "O"
        ) ;_ hr&bracket
        (add-to-list 't-lst
          (vlax-put-property-r
            (add-text
              ubk
              (list
                (- (+ b-flt_width b-gap -3))
                (+ (* 4 b-flt_rise_hgt) 78.75)
              ) ;_ list
              "FOF"
              3.0
              1.0
              'MiddleCenter
            ) ;_ add-text
            "Rotation"
            (dtr 90)
          ) ;_ vlax-put-property-r
        ) ;_ add-to-list
      ) ;_ condif
      ( (wcmatch b-flt_o-rail_type "*Stair*")
        (hr&bracket
          ubk
          (list
            (- (+ b-flt_width (if (= "0" b-flt_o-rail_topmnt) -2.33 -3.83)))
            (+ b-flt_rise_hgt 34)
          ) ;_ list
          -1
          "S"
          "O"
        ) ;_ hr&bracket
        (add-to-list 's-lst
          (add-rectangle
            ubk
            ((if (= "0" b-flt_o-rail_topmnt) - +) 1.5)
            (- (+ 42.75 (- (* 3 b-flt_rise_hgt) (* 2.0 b-flt_i-nosing_bot))))
            (list (- b-flt_width) (+ (* 4 b-flt_rise_hgt) 42.75))
          ) ;_ add-rectangle
        ) ;_ add-to-list
      ) ;_ condif
      ( (= T) (princ))
    ) ;_ cond

    (format)

  ) ;_ defun-q rail-section-b-flight
  (defun-r 'rail-section-b-flight)

  (defun-q rail-section-dims ( / y-org s-lst r-lst h-lst t-lst d-lst)
    "create dimensions for rail section"
    (setq y-org (+ (* 4 b-flt_rise_hgt) 72.75))
    (add-to-list 'd-lst
      (vla-adddimrotated ; lower stair width
        lbk
        (3dpt 0 (- a-flt_i-nosing_top a-flt_i-string_dpt))
        (3dpt (- a-flt_width) (- a-flt_o-nosing_top a-flt_o-string_dpt))
        (3dpt 0 -36)
        0
      ) ;_ vla-adddimrotated
    ) ;_ add-to-list d-lst
    (mapcar
     '(lambda (off txt)
        (add-to-list 't-lst
          (add-text
            lbk
            (mapcar '-
              (safearray-value
                (variant-value
                  (vlax-get-property (last d-lst) "TextPosition")
                ) ;_ variant-value
              ) ;_ safearray-value
              (list 0 off 0)
            ) ;_ mapcar
            txt
            3.0
            1.0
            'MiddleCenter
          ) ;_ add-text
        ) ;_ add-to-list
      ) ;_ lambda
     '(9.0 13.5)
     '("OUTSIDE OF" "STRINGERS")
    ) ;_ mapcar
    (if (wcmatch a-flt_o-rail_type "*Wall*")
      (progn
        (add-to-list 'd-lst
          (vla-adddimrotated ; lower stair gap
            lbk
            (3dpt (- a-flt_width) (- a-flt_o-nosing_top a-flt_o-string_dpt))
            (3dpt (- (+ a-flt_width a-gap)) -18)
            (3dpt 0 -36)
            0
          ) ;_ vla-adddimrotated
        ) ;_ add-to-list d-lst
        (add-to-list 't-lst
          (add-text
            lbk
            (list (- (+ a-flt_width a-gap 8.0)) -39.0)
            "GAP"
            3.0
            1.0
            'MiddleCenter
          ) ;_ add-text
        ) ;_ add-to-list
      ) ;_ progn
    ) ;_ if
    (add-to-list 'd-lst
      (vla-adddimrotated ; upper stair width
        ubk
        (3dpt 0 (- b-flt_i-nosing_bot (- b-flt_i-string_dpt b-flt_rise_hgt)))
        (3dpt (- b-flt_width) (- b-flt_o-nosing_bot (- b-flt_o-string_dpt b-flt_rise_hgt)))
        (3dpt 0 -36)
        0
      ) ;_ vla-adddimrotated
    ) ;_ add-to-list d-lst
    (mapcar
     '(lambda (off txt)
        (add-to-list 't-lst
          (add-text
            ubk
            (mapcar '-
              (safearray-value
                (variant-value
                  (vlax-get-property (last d-lst) "TextPosition")
                ) ;_ variant-value
              ) ;_ safearray-value
              (list 0 off 0)
            ) ;_ mapcar
            txt
            3.0
            1.0
            'MiddleCenter
          ) ;_ add-text
        ) ;_ add-to-list
      ) ;_ lambda
     '(9.0 13.5)
     '("OUTSIDE OF" "STRINGERS")
    ) ;_ mapcar
    (if (wcmatch b-flt_o-rail_type "*Wall*")
      (progn
        (add-to-list 'd-lst
          (vla-adddimrotated ; upper stair gap
            ubk
            (3dpt (- b-flt_width) (- b-flt_o-nosing_bot (- b-flt_o-string_dpt b-flt_rise_hgt)))
            (3dpt (- (+ b-flt_width b-gap)) -18)
            (3dpt 0 -36)
            0
          ) ;_ vla-adddimrotated
        ) ;_ add-to-list d-lst
        (add-to-list 't-lst
          (add-text
            ubk
            (list (- (+ b-flt_width b-gap 8.0)) -39.0)
            "GAP"
            3.0
            1.0
            'MiddleCenter
          ) ;_ add-text
        ) ;_ add-to-list
      ) ;_ progn
    ) ;_ if
    (add-to-list 'd-lst
      (vla-adddimrotated ; between stairs
        lbk
        (3dpt 0 (- a-flt_i-nosing_top a-flt_i-string_dpt))
        (3dpt a-flt_dist_btwn (- b-flt_i-nosing_bot (- b-flt_i-string_dpt b-flt_rise_hgt)))
        (3dpt 0 -27)
        0
      ) ;_ vla-adddimrotated
    ) ;_ add-to-list d-lst
    (if
      (and
        (wcmatch a-flt_o-rail_type "*Wall*")
        (not (wcmatch a-flt_i-rail_type "*Wall*"))
        (not (wcmatch b-flt_i-rail_type "*Wall*"))
        (wcmatch b-flt_o-rail_type "*Wall*")
      ) ;_ and
      (add-to-list 'd-lst
        (vla-adddimrotated ; overall clear
          blk
          (3dpt (- (+ (/ a-flt_dist_btwn 2.0) a-flt_width a-gap)) y-org)
          (3dpt (+ (/ a-flt_dist_btwn 2.0) b-flt_width b-gap) y-org)
          (3dpt 0 y-org)
          0
        ) ;_ vla-adddimrotated
      ) ;_ add-to-list
    ) ;_ if

    (if
      (and
        (wcmatch a-flt_o-rail_type "*Wall*")
        (wcmatch a-flt_i-rail_type "*Wall*")
      ) ;_ and
      (add-to-list 'd-lst
        (vla-adddimrotated ; a-flt clear
          lbk
          (3dpt a-gap y-org)
          (3dpt (- (+ a-flt_width a-gap)) y-org)
          (3dpt 0 y-org)
          0
        ) ;_ vla-adddimrotated
      ) ;_ add-to-list
    ) ;_ if

    (if
      (and
        (wcmatch b-flt_o-rail_type "*Wall*")
        (wcmatch b-flt_i-rail_type "*Wall*")
      ) ;_ and
      (add-to-list 'd-lst
        (vla-adddimrotated ; b-flt clear
          ubk
          (3dpt b-gap y-org)
          (3dpt (- (+ b-flt_width b-gap)) y-org)
          (3dpt 0 y-org)
          0
        ) ;_ vla-adddimrotated
      ) ;_ add-to-list
    ) ;_ if

    (format)
  ) ;_ defun-q rail-section-dims
  (defun-r 'rail-section-dims)

  (defun-q rail-section-g-btwn (wid / off dat s-lst r-lst h-lst t-lst d-lst)
    "create section for guard between stairs"
    (setq
      off (list
            (if (= "0" a-flt_i-rail_topmnt) 1.5 0.0)
            (if (< wid 7.0) -0.25 0.125)
            0.0
          ) ;_ list
      dat (with-data a-dat '((stair-xdata->guard-xdata)))
      dat (car (filter dat '(= "btwn" (xd-value "location" x))))
    ) ;_ setq
    (mapcar
     '(lambda (ent) (add-to-list 's-lst ent))
      (add-calcd-objs
        lbk
        nil
        (mapcar
         '(lambda (lst)
            (cons
              (if (null (xd-value "ins" (car lst)))
                (append (car lst) (list (list "ins" off)))
                (subst-key "ins"
                  (mapcar '+ off (xd-value "ins" (car lst)))
                  (car lst)
                ) ;_ subst-key
              ) ;_ if
              (cdr lst)
            ) ;_ cons
          ) ;_ lambda
          (calc-guard-rail dat)
        ) ;_ mapcar
      ) ;_ add-calcd-objs
    ) ;_ mapcar
    (format)
  ) ;_ defun-q rail-section-g-btwn
  (defun-r 'rail-section-g-btwn)

  (defun-q hr&bracket (con ins dir stl i/o / y-org g-hgt tmp)
    "create of hr and bracket for sr or wr"
    (setq y-org (+ (* 4 b-flt_rise_hgt) 42.75 12.0))
    (setq g-hgt (+ (if (= con lbk) 0 (* 4 b-flt_rise_hgt)) 42.75))
    (add-to-list 'r-lst (vla-addcircle con (3dpt ins) 0.83))
    (mapcar
     '(lambda (l) (add-to-list 'r-lst (add-polyline con '(0 0) l nil)))
      (mapcar
       '(lambda (x)
          (mapcar
           '(lambda (y) (mapcar '+ ins (list x y)))
            (list 0 (if (= con lbk) -18.0 18.0))
          ) ;_ mapcar
        ) ;_ lambda
       '(-0.83 0.83)
      ) ;_ mapcar
    ) ;_ mapcar
    (add-to-list 's-lst
      (offset&close
        (setq tmp
          (add-polyline
            con
            ins
            (fillet-all-pts
              (mapcar
               '(lambda (l) (mapcar '+ l '(0.0 -0.83)))
                (mapcar
                 '(lambda (p) (mapcar '* p (list dir 1)))
                  (if (= stl "W")
                   '((0 0) (0 -1.375) (2.2050 -1.375) (2.2050 -4.0))
                   '((0 0) (0 -1.5) (2.2363 -2.5) (2.2363 -4.0))
                  ) ;_ if
                ) ;_ mapcar
              ) ;_ mapcar
              0.375
            ) ;_ fillet-all-pts
            nil
          ) ;_ add-polyline
        ) ;_ setq
        (if (= stl "W") 0.125 0.09375)
        T
        nil
      ) ;_ offset&close
    ) ;_ add-to-list
    (vla-delete tmp)
    (add-to-list 'd-lst
      (vlax-put-property-r
        (vla-adddimrotated ; min dim
          con
          (3dpt
            (+ (car ins) (* dir (if (= i/o "O") 0.83 2.33)))
            (cond
              ( (= i/o "O") (+ (cadr ins) (if (= con lbk) 0.0 18.0)))
              ( (= stl "W") y-org)
              ( (= stl "S") g-hgt)
            ) ;_ cond
          ) ;_ 3dpt
          (3dpt
            (+ (car ins) (* dir (if (= i/o "O") 2.33 0.83)))
            (cond
              ( (= i/o "I") (+ (cadr ins) (if (= con lbk) 0.0 18.0)))
              ( (= stl "W") y-org)
              ( (= stl "S") g-hgt)
            ) ;_ cond
          ) ;_ 3dpt
          (3dpt 0 y-org)
          0
        ) ;_ vla-adddimrotated
        "TextOverride"
        "1 1/2 MIN"
      ) ;_ vlax-put-property-r
    ) ;_ add-to-list
    (add-to-list 'd-lst
      (vlax-put-property-r
        (vla-adddimrotated ; max dim
          con
          (3dpt
            (+ (car ins) (* dir (if (= i/o "O") -0.83 2.33)))
            (cond
              ( (= i/o "O") (+ (cadr ins) (if (= con lbk) 0.0 18.0)))
              ( (= stl "W") (+ y-org 9.0))
              ( (= stl "S") g-hgt)
            ) ;_ cond
          ) ;_ 3dpt
          (3dpt
            (+ (car ins) (* dir (if (= i/o "O") 2.33 -0.83)))
            (cond
              ( (= i/o "I") (+ (cadr ins) (if (= con lbk) 0.0 18.0)))
              ( (= stl "W") (+ y-org 9.0))
              ( (= stl "S") g-hgt)
            ) ;_ cond
          ) ;_ 3dpt
          (3dpt 0 (+ y-org 9.0))
          0
        ) ;_ vla-adddimrotated
        "TextOverride"
        "4 1/2 MAX"
      ) ;_ vlax-put-property-r
    ) ;_ add-to-list
  ) ;_ defun-q hr&bracket
  (defun-r 'hr&bracket)

  (defun-q guard-section (ins / blk con tab ext)
    "creates a guard rail section"
    (expect-with-data "guard-section")
    (setq
      blk (p-blk "section")
      con (read lpost_con)
      tab lpost_tab
      ext (- (?n lpost_ext) (if (member con '(41 42 48)) 0.25 0.0))
    ) ;_ setq
    (fill-section (read guard_sty))
    (set-active-layer "HIDDEN")
    (add-shape blk (list -0.75 guard_hgt) "HSS1.5x1.5x3/16")
    (cond
      ( (= 52 (guard-con-read lpost_con))
        (add-shape blk (list -0.75 (- 1.5 lpost_ext)) "HSS1.5x1.5x3/16")
      ) ;_ condif
      ( (= 52 (guard-con-read rpost_con))
        (add-shape blk (list -0.75 (- 1.5 rpost_ext)) "HSS1.5x1.5x3/16")
      ) ;_ condif
      ( (= T) (list))
    ) ;_ cond
    (set-active-layer "SOLID")
    (if (= guard_kick "1")
      (apply
       '(lambda (h y) (add-rectangle blk 0.25 h (list 0 y)))
        (cond
          ( (member con '(41 42)) '(2 0.25))
          ( (= 46 con) '(4 -1.5))
          ( (= T) '(2 0))
        ) ;_ cond
      ) ;_ apply
    ) ;_ if
    (cond
      ( (member con '(41 42 48))
        (apply
         '(lambda (w x) (add-rectangle blk w -0.25 (list x (- ext))))
          (if (= 48 con) '(20.0 -10.75) '(6.0 -3.75))
        ) ;_ apply
      ) ;_ condif
      ( (member con '(51 07X))
        (add-rectangle blk tab 6.0 (list 0 (- ext)))
      ) ;_ condif
      ( (= con 47)
        ( (lambda ( / lst)
            (setq lst '((0 0) (#tab 0) (#tab 5) (#(- tab 1) 6) (0 6)))
            (add-polyline blk (list 0 (- ext)) (#! lst) T)
          ) ;_ lambda
        ) ;_ lambda-func
      ) ;_ condif
      ( (= T) (list))
    ) ;_ cond
    (add-rectangle blk -1.5 (+ guard_hgt ext) (list 0 (- ext)))
    (setq blk (insert-block modelSpace ins blk))
    blk
  ) ;_ defun-q guard-section
  (defun-r 'guard-section)

  (defun-q fill-section (sty / y p)
    "generates style specific fill for guard rail section"
    (set-active-layer "HIDDEN")
    (cond
      ( (= sty 100)
        (if (all-X12) (add-shape blk '(-0.75 1.5) "HSS1.5x1.5x3/16"))
        (set-active-layer "SOLID")
        (vla-addcircle blk (3dpt 0.83 (- guard_hgt 20.83)) 0.83)
      ) ;_ condif
      ( (= sty 200)
        (add-shape blk (list -0.75 (- guard_hgt 4.5)) "HSS1.5x1.5x3/16")
        (if (all-X12)
          (foreach y (list (- guard_hgt 9.0) 1.5)
            (add-shape blk (list -0.75 y) "HSS1.5x1.5x3/16")
          ) ;_ foreach
        ) ;_ if
        (set-active-layer "SOLID")
        (if (and (= guard_hand "0") (not (all-X12)))
          (vla-addcircle blk (3dpt 0.83 (- guard_hgt 9.08)) 0.83)
        ) ;_ if
        (setq y (- guard_hgt 14.33))
        (while (>= y 4.705)
          (vla-addcircle blk (3dpt 0.83 y) 0.83)
          (setq y (- y 5.535))
        ) ;_ while
      ) ;_ condif
      ( (= sty 300)
        (if (all-X12) (add-shape blk '(-0.75 1.5) "HSS1.5x1.5x3/16"))
        (setq y (- guard_hgt 5.25))
        (while (>= y 5.25)
          (foreach obj
            (add-shape blk (list -0.75 y) "HSS1.5x0.75x0.083")
            (vla-put-color-r obj 253)
          ) ;_ foreach
          (setq y (- y 5.25))
        ) ;_ while
      ) ;_ condif
      ( (= sty 400)
        (add-shape blk
          (list -0.75 (if (all-X12) 1.5 (- guard_hgt 35.75)))
          "HSS1.5x1.5x3/16"
        ) ;_ add-shape
        (vla-put-color-r
          (add-rectangle blk
            -0.5 (- guard_hgt (if (all-X12) 3.0 8.5))
            (list -0.5 (if (all-X12) 1.5 (- guard_hgt 35.75)))
          ) ;_ add-rectangle
          253
        ) ;_ vla-put-color-r
      ) ;_ condif
      ( (= T) (list))
    ) ;_ cond
    (if (= guard_hand "1")
      (progn
        (set-active-layer "SOLID")
        (setq
          y  (- guard_hgt (if (< sty 300) 9.08 7.955))
          p '( (0.0 -0.83) (0.0 -1.83)
               (-2.23625 -3.205) (-2.23625 -4.205)
             ) ;_ quoted-list
          p  (fillet-all-pts p 0.375)
          p  (add-polyline blk (list 2.33 y) p nil)
        ) ;_ setq
        (offset&close p 0.09375 T nil)
        (vla-delete p)
        (set-active-layer "RAILS")
        (vla-addcircle blk (3dpt 2.33 y) 0.83)
      ) ;_ progn
    ) ;_ if
  ) ;_ defun-q fill-section
  (defun-r 'fill-section)
