  (set-file-docstring "Decking functions")

  (defun-q add-decking (add-to pt1 pt2 / lst lng off)
    "adds decking to passed container between two passed points"
    (declare (vars (add-to vla-object) (pt1 list (point-p pt1)) (pt2 list (point-p pt2))))
    (setq lst
      (list
       '(0.0 0.0 0.0)
       '(0.375 1.4522 0.0)
       '(3.875 1.4522 0.0)
       '(4.25 0.0 0.0)
      ) ;_ list
    ) ;_ setq
    (setq lng (caar (reverse lst)))
    (while (< lng (- (distance pt1 pt2) 7.0))
      (append! 'lst
        (mapcar
         '(lambda (add) (mapcar '+ add (last lst)))
          (list
           '(1.75 0.0 0.0)
           '(2.125 1.4522 0.0)
           '(5.625 1.4522 0.0)
           '(6.0 0.0 0.0)
          ) ;_ list
        ) ;_ mapcar
      ) ;_ append!
      (setq lng (caar (reverse lst)))
    ) ;_ while
    (setq off (list (/ (- (distance pt1 pt2) lng) 2.0) 0.0 0.0))
    (setq lst
      (append
       '((0.0 0.0 0.0))
        (mapcar '(lambda (pt) (mapcar '+ pt off)) lst)
        (list (mapcar '+ (last lst) (mapcar '* off '(2 0 0))))
      ) ;_ append
    ) ;_ setq
    (offset&close
      (add-polyline
        add-to
        (car (vl-sort (list pt1 pt2) (sort-by 'car '<)))
        lst
        nil
      ) ;_ add-polyline
      -0.0478
      nil
      0.0
    ) ;_ offset&close
  ) ;_ defun-q add-decking
  (defun-r 'add-decking)

  (defun-q decking-vertices (lng / obj ret)
    "Returns a list of vertices for decking of passed length"
    (setq
      obj (add-decking modelspace '(0 0) (list lng 0))
      ret (safearray->list (vlax-variant-value (vla-get-Coordinates obj)))
    ) ;_ setq
    (vla-delete obj)
    ret
  ) ;_ defun-q decking-vertices
  (defun-r 'decking-vertices)
