(add-to-list 'sub-dialogs "rail_opts") 

(setq rail_opts-popup-keys '("i-rail_type"
                             "o-rail_type")
      rail_opts-dist-keys '("i-rail_top_ext"
                            "i-rail_bot_ext"
                            "i-rail_cutoff"
                            "o-rail_top_ext"
                            "o-rail_bot_ext"
                            "o-rail_cutoff")
      rail_opts-toggle-keys '("rail_lvl-off"
                              "rail_no_guard_btwn"
                              "i-rail_no_bot_guard"
                              "i-rail_top_dloop"
                              "i-rail_bot_dloop"
                              "i-rail_no_top_guard"
                              "i-rail_no_bot_guard"
                              "i-rail_topmnt"
                              "o-rail_top_dloop"
                              "o-rail_bot_dloop"
                              "o-rail_no_top_guard"
                              "o-rail_no_bot_guard"
                              "o-rail_topmnt")
      rail_opts-keys (append rail_opts-popup-keys
                             rail_opts-dist-keys
                             rail_opts-toggle-keys)
      rail-types '(("None")
                   ("Stair Rail"
                    "top_ext"
                    "bot_ext"
                    "top_dloop"
                    "bot_dloop"
                    "no_top_guard"
                    "no_bot_guard"
                    "topmnt")
                   ("Chop-top Stair Rail"
                    "bot_ext"
                    "cutoff"
                    "top_dloop"
                    "bot_dloop"
                    "no_bot_guard"
                    "topmnt")
                   ("Wall Rail" "top_dloop" "bot_dloop")))

;; Init function for rail options sub-dialog
(defun rail_opts-sub-init (dummy / local-scope)

  (defun local-scope ( /
                       tmp
                       popup-keys
                       dist-keys
                       int-keys
                       plain-string-keys
                       toggle-keys
                       tile-actions
                       default-actions
                       dialog-ties
                       sub-dialogs
                       dialog-after-load
                       dialog-before-done
                       rail-types-strings
                       )
    ;; default action for both rail type popup tiles
    (defun rail_type-action (key value / lr)
      (setq lr (substr key 1 7))
      (foreach key (remove rail_opts-keys
                           '(or (not (begins-with x lr))
                                (ends-with x "rail_type")))
               (set_tile key "")
               (mode_tile key 1))
      (foreach key (cdr (assoc value rail-types))
               (setq key (strcat lr key))
               (mode_tile key 0)
               (set_tile key (if (member key rail_opts-dist-keys) "0.0" "0"))))

    (defun dialog-after-load ()
      (if multi
          (foreach key rail_opts-keys
             (dialog-add-action (strcat "enable_" key) '(dialog-toggle-enable $value #key)))
        ;; turn on only keys which pertain to this invocation of the dialog
        (foreach side '("i" "o")
           (foreach key (cdr (assoc (dialog-tile-val (strcat side "-rail_type")) rail-types))
              (mode_tile (strcat side "-rail_" key) 0)))))

    (setq rail-types-strings (mapcar 'car rail-types)
          popup-keys (mapcar '(lambda(x) (cons x 'rail-types-strings)) rail_opts-popup-keys)
          dist-keys rail_opts-dist-keys
          toggle-keys rail_opts-toggle-keys)
    (if (not multi)
        (setq default-actions '(("i-rail_type" . rail_type-action)
                                ("o-rail_type" . rail_type-action))))
    (if (setq tmp (dialog-init (if multi
                                   "stair/rail_opts-multi.dcl"
                                 "stair/rail_opts.dcl")
                               "rail_opts"
                               rail_opts-val))
        (setq rail_opts-val (remove tmp '(= (cdr x) nil)))))
  (local-scope))
