;; Enhanced standard library
;; this file is automatically loaded into every new document namespace

(defun util-load (name)
  (psc-load (strcat "util/" name ".lsp")))

(mapcar 'util-load '(
		     "alias"		; convenience renamings and wrappers
		     "arithmetic"	; basic math, rounding
		     "comparison"	; comparisons and sorting
		     "conversion"	; type/value conversion
		     "document"		; functions pertaining to documents
		     "error"		; error handling and debugging
		     "file"		; reading and writing files
		     "function"		; function-handling functions
		     "geometry"		; points, angles, planes, pipe bending
		     "job"		; related to job folder
                     "json"		; Javascript Object Notation generation
		     "list"		; list-handling functions
		     "object"		; entity-handling functions index
		     "selection"	; selection sets
		     "string"		; string manipulation
		     "symbol"		; symbol manipulation
		     "time"		; time and date
		     "xdata"		; xdata and data list handling
                     "documentation"	; functions pertaining to documenting the code
                     "test"		; functions pertaining to testing the code
		     ))
