(set-file-docstring
 "Functions related to the job directory")

(defun-q find-job-dir ( / path)
  "Returns the root job directory if we are a descendant of one"
  (setq path (reverse (strsplit (vla-get-Path acadDoc) "\\")))
  (while (and path
              (not (or (wcmatch (car path) "#### - *")
                       (wcmatch (car path) "Job####"))))
    (setq path (cdr path)))
  (if path (strjoin (reverse path) "\\")))
(defun-r 'find-job-dir)

(defun-q get-job-info (/ job-dir job-info)
  "Return the current job info as a data list"
  (if (setq job-dir (find-job-dir))
      (if (member "job.dat" (vl-directory-files job-dir))
          (setq job-info (read-key-val-file (strcat job-dir "/job.dat")))
          (error "FAB: No job info file found. Run JOBINFO command."))
      (error "FAB: Not in a job folder"))
  (cons (list "dir" job-dir)
        job-info))
(defun-r 'get-job-info)
