(set-file-docstring "Dimension handling functions")

  (defun dim-p (?dim)
    (cond
      ( (not (member (type ?dim) '(ename vla-object))) nil)
      ( (= (type ?dim) 'ename)
        (= "DIMENSION" (cdr (assoc 0 (entget ?dim))))
      ) ;_ condif
      ( (= (type ?dim) 'vla-object)
        (= "AcDbRotatedDimension" (vla-get-objectname ?dim))
      ) ;_ condif
      ( (= T) nil)
    ) ;_ cond
  ) ;_ defun dim-p

  (defun-q tog-bg-fill (dim / ename fill)
    "Toggles background fill for passed dimension object or entity"
    (declare (vars (dim nil (dim-p dim))))
    (setq ename (if (= (type dim) 'ename) dim (vlobj>ename dim)))
    (setq fill (getpropertyvalue ename "dimtfill"))
    (setpropertyvalue ename "dimtfill" (if (zerop fill) 1 0))
    dim
  ) ;_ defun-q tog-bg-fill
  (defun-r 'tog-bg-fill)
